/*-------------------------------------------------------------------------*/
/*      Dribble.java                                                       */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*   ɥ֥ץ졼ɽ饹                 */
/*                                                    */ 
/******************************************************/
package Analyzer;

//my package
import Information.*;

//jdk package
import java.util.*;
public class Dribble {

    /*******************************************************/
    /*                 instance variable                   */
    /*******************************************************/

    Vector v = new Vector();
    int member;
    int side;

    /*******************************************************/
    /*                    constructor                      */
    /*******************************************************/
    
    Dribble(int member, int side, DribblePoint p1, DribblePoint p2){

	this.member = member;
	this.side   = side;

	v.addElement(p1);
	v.addElement(p2);

    }

    /*******************************************************/
    /*                      method                         */
    /*******************************************************/
    public int getMember(){

	return member;

    }

    public int getSide(){

	return side;

    }

    public void addPoint(DribblePoint p){

	v.addElement(p);

    }

    public Vector getDribblePoints(){

	return v;

    }

    public DribblePoint getFirstDribble(){

	return (DribblePoint)v.firstElement();

    }

    public DribblePoint getLastDribble(){

	return (DribblePoint)v.lastElement();

    }

    public double getTotalDistance(){

	DribblePoint dp1, dp2;
	double dist = 0.0;

	double x1,x2,y1,y2,xx,yy;

	Enumeration e = v.elements();

	dp1 = (DribblePoint)e.nextElement();

	while(e.hasMoreElements()){

	    dp2 = (DribblePoint)e.nextElement();
    
	    x1 = dp1.x ;
	    y1 = dp1.y ;
	    x2 = dp2.x ;
	    y2 = dp2.y ;
   
	    xx = x2-x1;
	    yy = y2-y1;

	    dist += Math.sqrt(xx*xx + yy*yy);

	    dp1 = dp2;

	}
	
	return dist;
    }

}

