/*-------------------------------------------------------------------------*/
/*      DribbleAnalyzer.java                                               */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*               ɥ֥ʬϤ륯饹             */
/*                                                  */
/****************************************************/
package Analyzer;

//my package
import java.util.*;

//jdk packege
import Information.*;

//ѥɥ֥Ƚꤹ륯饹
public class DribbleAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ
    Vector dribbleVector;

    //Ȥǡ
    Vector kickVector;

    boolean continuousPlay = false;

    //ߥɥ֥Ǥ뤫ɤ
    boolean isDribbling;

    //߿ʹΥɥ֥
    Dribble d;

    /*********************************************/
    /*                                       */
    /*********************************************/

    //ɥ֥ȸʤεΥ
    public static final double MIN_DRIBBLE_DISTANCE = 1.0;

    //ʥɥ֥
    public static final int NEW_DRIBBLE = 0;
    public static final int CONTINUAL_DRIBBLE = 1;
    
    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public DribbleAnalyzer(KickAnalyzer ka, PlayModeAnalyzer pma){

	ka.addObserver(this);
	pma.addObserver(this);

	this.kickVector = ka.getKickVector();
	
	dribbleVector = new Vector();
    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public Vector getDribbleVector(){

	return dribbleVector;

    }

    public double getCurrentDribbleDistance(){

	return d.getTotalDistance();

    }

    public Dribble getCurrentDribble(){

	return d;

    }

    public void update(Observable o, Object arg){

	//play_modeѲ
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		continuousPlay =false;
		isDribbling = false;
	    }

	//kickѲ
	}else if (arg instanceof KickAnalyzer){

	    if (continuousPlay){

		analyze();

	    }else{

		continuousPlay = true;
		isDribbling = false;

	    }

	}
    }

    public void analyze(){
		
	int kickSize = kickVector.size(); 

	//ޤkick򣱲󤷤Ǥ롣
	if (kickSize == 1){

	    return;				
	
	}
		
	Kick beforeKick = (Kick)kickVector.elementAt(kickSize-2);	
	Kick thisKick   = (Kick)kickVector.elementAt(kickSize-1);

	if (thisKick.getSide() == beforeKick.getSide() && 
            thisKick.getMember() == beforeKick.getMember()){

	    if(!isDribbling){

		d = new Dribble(thisKick.member, thisKick.getSide(), new DribblePoint(
                beforeKick.posX, beforeKick.posY,beforeKick.time)
                ,new DribblePoint(thisKick.posX,thisKick.posY, thisKick.time));
	     
		dribbleVector.addElement(d);
		isDribbling = true; 

		setChanged();
		notifyObservers(new Integer(NEW_DRIBBLE));

	    }else{

		//ɥ֥ɲ
		d.addPoint(new DribblePoint(thisKick.posX,
                                            thisKick.posY,
					    thisKick.time));

		setChanged();
		notifyObservers(new Integer(CONTINUAL_DRIBBLE));

		System.out.println("dribbling:"+thisKick.member);
			    
	    }
	}else{

	    isDribbling = false;
	}

    }
    
}


