/*-------------------------------------------------------------------------*/
/*      FormationAnalyzer.java                                             */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/10/22                                             */
/*-------------------------------------------------------------------------*/

package Analyzer;
//jdk packege
import java.util.*;

//my package
import Information.*;
import Strategy.*;
import GUI.*;
import Utility.*;

public class FormationAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ

    double ball_pos_percentage, ball_pos_percentage0;
    double my_team_pos, my_team_pos0;

    int time0 = 0;
    int time  = 0;

    //Ȥǡ
    OppAttackPatternAnalyzer oapa;
    BaseSeeInformation        bsi;
    StaminaAnalyzer            sa; 

    MessageSender ms;

    int width_form, width_form0;
    int length_form, length_form0;

    int formation_type, formation_type0;

    PositionTable posTable = new PositionTable();

    boolean useSweeper = false; 
    boolean isTransratedPosition;

    //ݥؤäȤɽѴơ֥
    //
    // i ֹͤ i+1 μºݤΥץ졼ֹɽ
    // ȤǤȽ񤫤ʤ
    //

    int[] positionTransTable = {1,2,3,4,5,6,7,8,9,10,11};
    int[] positionTransTable0 = {1,2,3,4,5,6,7,8,9,10,11};
    
    /*********************************************/
    /*                                       */
    /*********************************************/

    public static final int NORMAL = 1;
    public static final int NARROW = 2;
    public static final int WIDE  =3;

    public static final int DEFENSIVE = 4;
    public static final int OFFENSIVE = 5;

    public static int GK = 1;
    public static int DF = 2;
    public static int MF = 3;
    public static int OH = 4;
    public static int FW = 5;

/*	
    public static double startPos1[][] = {
    {-47,0},
    {-20,17},{-20,7},{-20,-7},{-20,-17},
    {-10,15},{-10,-15},{-14,0},
    {-10,0},{-2,12},{-2,-12}
    };
	
    public static double stdPos2[][] = {
    {-47,0},
    {-20,17},{-20,7},{-20,-7},{-20,-17},
    {5,15},{5,-15},{-5,0},
    {10,0},{30,12},{30,-12}
    };
	
    public static double startPosWide1[][] = {
    {-47,0},
    {-20,22},{-20,8.5},{-20,-8.5},{-20,-22},
    {-10,15},{-10,-15},{-14,0},
    {-10,0},{-2,12},{-2,-12}
    };
	
    public static double stdPosWide1[][] = {
    {-47,0},
    {-20,22},{-20,8.5},{-20,-8.5},{-20,-22},
    {5,15},{5,-15},{-5,0},
    {10,0},{30,12},{30,-12}
    };
	
    public static double startPosNarrow1[][] = {
    {-47,0},
    {-20,17},{-20,4.5},{-20,-4.5},{-20,-17},
    {-10,15},{-10,-15},{-14,0},
    {-10,0},{-2,12},{-2,-12}
    };
	
    public static double stdPosNarrow1[][] = {
    {-47,0},
    {-20,17},{-20,4.5},{-20,-4.5},{-20,-17},
    {5,15},{5,-15},{-5,0},
    {10,0},{30,12},{30,-12}
    };
*/

    public static final double DEFENSIVE_DIST = 5;

    public static double[][] presentStartPos; 
    public static double[][] presentStdPos  ;
    public static double[][] prevStartPos   ;
    public static double[][] prevStdPos     ;
 
    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public FormationAnalyzer(OppAttackPatternAnalyzer oapa, MessageSender ms, BaseSeeInformation bsi, PlayModeAnalyzer pa, StaminaAnalyzer sa, int formation_type){

	this.oapa = oapa;
	this.ms   = ms;
	this.bsi  = bsi;
	this.sa   = sa;

	this.formation_type0 = this.formation_type = formation_type;

        presentStartPos = posTable.startPos[formation_type]; 
        presentStdPos   = posTable.stdPos[formation_type];
        prevStartPos    = posTable.startPos[formation_type];
        prevStdPos      = posTable.stdPos[formation_type];

	width_form = width_form0 = NORMAL;
	length_form = length_form0 = NORMAL;

	pa.addObserver(this);

    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public void setSweeper(boolean sweeper){

	useSweeper = sweeper;

    }

    public double[][] getPosition(){

	return presentStdPos;

    }
    public double[][] getStartPosition(){

	return presentStartPos;

    }

    public double[][] getPrevPosition(){

	return prevStdPos;

    }

    public double[][] getPrevStartPosition(){

	return prevStartPos;

    }


    public void update(Observable o, Object arg){

	if (o instanceof PlayModeAnalyzer){
	    
	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	/*
	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF
                && bsi.time >=1
		&& bsi.play_mode != CParam.PLAY_ON 
		&& bsi.play_mode != CParam.DROP_BALL){
       */

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF ||
		pma.getInformation() == PlayModeAnalyzer.PLAY_OFF_TO_OFF){

		analyze(pma);

	    }

	}

	setChanged();
	notifyObservers();

    }
    
    public double getPosPercentage(){

	return ball_pos_percentage;

    }

    public double getMyTeamPos(){

	return my_team_pos;

    }

    public double getBeforePosPercentage(){

	return ball_pos_percentage0;

    }

    public double getBeforeMyTeamPos(){

	return my_team_pos0;

    }

    public int getTime(){

	return time;
	
    }
    
    public int getBeforeTime(){

	return time0;

    }

    public void analyze(){
    }


    public void analyze(PlayModeAnalyzer pma){
	

	System.out.println("test111!");

        if( pma.getCurrentPlayMode() == CParam.GOAL_R ||
	    pma.getCurrentPlayMode() == CParam.GOAL_L){

	    analyzeDefenseWideness();
	    checkPlayersStamina();
	    checkUseSweeper();
	
	    if(setPosition()){

		System.out.println("send");

	        send();
	    }
	}

	System.out.println("test222!");

	if(pma.getCurrentPlayMode() != CParam.DROP_BALL &&
	   pma.getCurrentPlayMode() != CParam.BEFORE_KICK_OFF &&
	   pma.getCurrentPlayMode() != CParam.KICK_OFF_L &&
	   pma.getCurrentPlayMode() != CParam.KICK_OFF_R &&
	   pma.getCurrentPlayMode() != CParam.OFFSIDE_L &&
	   pma.getCurrentPlayMode() != CParam.OFFSIDE_R){

	    if(checkPlayerTransrate()){

		sendForTransrate();

		prevStartPos = presentStartPos;
		prevStdPos   = presentStdPos;

		/*******************************************/
		/*           ˤʤݥ            */
		/*******************************************/
		presentStartPos = transratePosition(new PositionTable().startPos[formation_type]); 
		presentStdPos   = transratePosition(new PositionTable().stdPos[formation_type]);

	    }

	}
	
	setChanged();
	notifyObservers(this);

    }

    //ºݤֹ֤
    public int[] getDefendersUnum(){

	int tmp[] = new int[11];
	int count = 0;
	
	for (int i = 0; i <= 10; i++){

	    if(posTable.role[formation_type][i].equals("DF")){   

		tmp[count] = i+1;
		count ++;

	    }

	}

	if (count == 0){
	    
	    System.out.println("no defender!");
	    return null;

	}

	int[] ret = new int[count];

	for (int i = 0; i < count; i++){

	    ret[i] = tmp[i];

	}

	return ret;

    }


    /***************************************/
    /* ץ졼ΰ֤򴹤뤫ꤹ  */
    /***************************************/

    protected boolean checkPlayerTransrate(){
	
	//
	// moveޥɤѤǤȤ
	//
	if(canMoveCommand(bsi.play_mode)){
	    
	    if(sa.getMostDameNumber() <= 10 ){
	    
		return false;

	    }

	    int a = sa.getMostDamePlayer();
	    int b = sa.getMostGenkiPlayer();

	    System.out.println("genki!"+b);
	    System.out.println("dame!"+a);

	    swapPositionTransTable(a, b);
	    
	    sa.resetStamina(a);

	    return true;

	}else{

	    System.out.println("test3");

	    //ˤĤƤȤ뤫
	    if(sa.getMostDameNumber() <= 20){
	    
		return false;

	    }

	    double[][] pos = getPosition();

	    int a = sa.getMostDamePlayer();

	    System.out.println("dame!"+a);

	    int index = -1;
		
	    for(int i = 2; i <= 11; i++){

		if (i != a ){

		    if(Utility.getDistance(pos[a-1][0], pos[a-1][1],
					   pos[i-1][0],pos[i-1][1]) <= 20
		       && sa.getStaminaLackNumber(i) == 0){
			
			index = i;
	
			swapPositionTransTable(a, index);

			sa.resetStamina(a);

			System.out.println("genki!"+index);

			return true;

		    }
		}
	    }

	    if (index == -1){

		return false;

	    }


	}

	return false;


    }

    protected void swapPositionTransTable(int unum1, int unum2){

	int tmp1 = 1;
	int tmp2 = 1;

	for (int i = 0; i <= 10; i++){

	    if(positionTransTable[i] == unum1){
		    
		tmp1 = i;

	    }else if(positionTransTable[i] == unum2){

		tmp2 = i;

	    }
	}		    

	
	int tmp;

	tmp = positionTransTable[tmp1];
	positionTransTable[tmp1] = positionTransTable[tmp2];
	positionTransTable[tmp2] = tmp;

    }

    public void analyzeDefenseWideness(){

	int sideAttack = oapa.getAttackedNumber(0) + oapa.getAttackedNumber(1)
			 + oapa.getAttackedNumber(8) + oapa.getAttackedNumber(9);
	int centerAttack =oapa.getAttackedNumber(4) + oapa.getAttackedNumber(5);
	int totalAttack = oapa.getTotalAttacked();

	if(totalAttack >= 1){

	    if (((double)sideAttack / totalAttack) >= 0){
   	       
		System.out.println("wide formation");

		width_form0 = width_form;
	    	width_form  = WIDE;

	    }else if (((double)centerAttack / totalAttack) > 0.40){

		width_form0 = width_form;
	    	width_form  = NARROW;
		System.out.println("narrow formation");

	    }else {

		/*width_form0 = width_form;
	    	width_form  = NORMAL;
		System.out.println("normal formation");
		*/

	    }

	    setChanged();
	    notifyObservers(new Integer(width_form));


 	}
    }
    
    public void checkPlayersStamina(){

	int num = 0;
	for(int i = 1; i <= getDefenderNumber(); i++){

		if(sa.isStaminaLack(i+1)){

			num++;
		}
	}
	
	if(num>=2 && (bsi.team[Team.LEFT].score-bsi.team[Team.RIGHT].score <= -2)){
 	
		length_form0 = length_form;
	    	length_form  = DEFENSIVE;
		System.out.println("DEFENSIVE formation");

	}else{

		length_form0 = length_form;
	    	length_form  = NORMAL;
		System.out.println("normal formation");

	}		

    }

    protected int getDefenderNumber(){

	int num = 0;

	for(int i = 0; i <= 10; i++){
	    
	    if(posTable.role[formation_type][i].equals("DF")){   

		num++;

	    }
	}

	return num;
    }

    public void checkUseSweeper(){

	if(!useSweeper){

	    int driAttack, passAttack, totalAttack;
	    int myScore, eneScore;

	    driAttack = oapa.getOppDribbleAttackNumber();
	    passAttack = oapa.getOppPassAttackNumber();
	    totalAttack = oapa.getTotalAttacked();

	    myScore = bsi.team[Team.LEFT].score;
	    eneScore = bsi.team[Team.RIGHT].score;

	    if(driAttack >= 1){

		for(int i = 0; i<= 10; i++){

		    System.out.println("use sweeper");

		}

		useSweeper = true;
		ms.addMessage("(set Sweeper)");

	    }
	}
    }

    /**************************************************/
    /* ʬϷ̤鿷ʥݥ򥻥åȤ       */
    /* ͤϡݥѹ줿ɤ       */
    /**************************************************/
    protected boolean setPosition(){

	if ( (width_form0 == width_form) && (length_form0 == length_form) 
	   &&(formation_type0 == formation_type) ){

	    //ѹʤ
	    return false;

	}

	prevStartPos = presentStartPos;
        prevStdPos   = presentStdPos;

	/*******************************************/
	/*           ˤʤݥ            */
	/*******************************************/
        presentStartPos = transratePosition(new PositionTable().startPos[formation_type]); 
	presentStdPos   = transratePosition(new PositionTable().stdPos[formation_type]);

	//ݥؤ
	
	if(width_form == WIDE){

	    int[] defUnums = getDefendersUnum();

	    //üΥץ졼õ

	    //¦ѿindex
	    int minYindex = defUnums[0]-1;
	    int maxYindex = defUnums[0]-1;
	    double minY = presentStdPos[defUnums[0]-1][1];
	    double maxY = presentStdPos[defUnums[0]-1][1];

	    for(int i = 2; i <= getDefenderNumber(); i++){ 			

    		if(minY > presentStdPos[defUnums[i-1]-1][1]){

		    minY = presentStdPos[defUnums[i-1]-1][1];
		    minYindex = defUnums[i-1]-1;
		    
		}else if(maxY < presentStdPos[defUnums[i-1]-1][1]){

		    maxY = presentStdPos[defUnums[i-1]-1][1];
		    maxYindex = defUnums[i-1]-1;
		}

	    }

	    presentStdPos[minYindex][1] -= 10;
	    presentStartPos[minYindex][1] -= 10;

	    presentStdPos[maxYindex][1] += 10;
	    presentStartPos[maxYindex][1] += 10;

	    System.out.println("coming!");

	}else if(width_form == NARROW){

	    int[] defUnums = getDefendersUnum();

	    //üΥץ졼õ

	    //¦ѿindex
	    int minYindex = defUnums[0]-1;
	    int maxYindex = defUnums[0]-1;
	    double minY = presentStdPos[defUnums[0]-1][1];
	    double maxY = presentStdPos[defUnums[0]-1][1];

	    for(int i = 2; i <= getDefenderNumber(); i++){
 			
    		if(minY > presentStdPos[defUnums[i-1]-1][1]){

		    minY = presentStdPos[defUnums[i-1]-1][1];
		    minYindex = defUnums[i-1]-1;
		    
		}else if(maxY < presentStdPos[defUnums[i-1]-1][1]){

		    maxY = presentStdPos[defUnums[i-1]-1][1];
		    maxYindex = defUnums[i-1]-1;
		}
	    }	

	    if(getDefenderNumber() == 3){

		System.out.println("test2");

	        presentStdPos[minYindex][1] += 5;
	    	presentStartPos[minYindex][1] += 5;

	    	presentStdPos[maxYindex][1] -= 5;
	    	presentStartPos[maxYindex][1] -= 5;

	    }else if(getDefenderNumber() == 4){

		//Σͤ
		//Ѥʥɤɻ֤ʤΤǤʤä
		//ɤͤ顢ͤ˶ᤤΤ٤Ф褫ä
 		int[] index = new int[2];
		int count = 0;
	
		for(int i = 1; i <= 4; i++){

		    int unum = defUnums[i-1]-1;
	
		    if((unum != maxYindex) && (unum != minYindex)){
 	
			index[count] = unum;
			count++;
		    }
		}


		System.out.println("test1");

		double diff = Math.abs(presentStdPos[index[0]][1]) / 2;

		System.out.println("diff"+diff);

		if(presentStdPos[index[0]][1] > presentStdPos[index[1]][1]){

		    presentStdPos[index[0]][1] -= diff;
	    	    presentStartPos[index[0]][1] -= diff;

	    	    presentStdPos[index[1]][1] += diff;
	    	    presentStartPos[index[1]][1] += diff;
			
		}else{

		    presentStdPos[index[0]][1] += diff;
	    	    presentStartPos[index[0]][1] += diff;

	    	    presentStdPos[index[1]][1] -= diff;
	    	    presentStartPos[index[1]][1] -= diff;

		}
	    }

	}

	if(length_form == DEFENSIVE){

	    for(int i = 0; i <= 10; i++){
	    
	    	if(posTable.role[formation_type][i].equals("DF") ||
		   posTable.role[formation_type][i].equals("MF")){   

		    presentStdPos[i][0] -= DEFENSIVE_DIST;
	    	    presentStartPos[i][0] -= DEFENSIVE_DIST;

		    System.out.print("bakced"+i+"\t");


		}
	    }

	}

	return true;

    }

    protected double[][] transratePosition(double[][] pos){

	//ɤΤnew㤨

	double[][] newPos = new double[11][2];

	for(int i = 0; i <= 10; i++){

	    newPos[i][0] = pos[positionTransTable[i]-1][0];
	    newPos[i][1] = pos[positionTransTable[i]-1][1];
		   
	    System.out.println(newPos[i][0]+" "+newPos[i][1]);

	}

	return newPos;


    }

    protected void send(){

	String str0 = new String();
	String str = new String();

	double[][] pos = getPosition();
	double[][] pos0= getPrevPosition();
	double[][] startPos = getStartPosition();
	double[][] startPos0= getPrevStartPosition();

	for(int i = 0; i < 11; i++){
	    
	    double x = pos[i][0];
	    double y = pos[i][1];

	    double x0 = pos0[i][0];
	    double y0 = pos0[i][1];

	    double sx = startPos[i][0];
	    double sy = startPos[i][1];

	    double sx0 = startPos0[i][0];
	    double sy0 = startPos0[i][1];

	    //***********************************//
	    //ݥѹƤʤ   //
	    //ʥݥ         //
	    //***********************************//

	    if (x != x0 || y != y0 || sx != sx0 || sy != sy0){ 
	    
		str = "(Pos "+(i+1)+" "+startPos[i][0]+" "+startPos[i][1]+" "+pos[i][0]+" "+pos[i][1]+")";
		ms.addMessage(str);
 
	    }
	}

	
    }

    protected void sendForTransrate(){

	double[][] pos = getPosition();
	double[][] pos0= getPrevPosition();
	double[][] startPos = getStartPosition();
	double[][] startPos0= getPrevStartPosition();

	//ǤФ
	for(int i = 0; i<=10; i++){

	    System.out.print(positionTransTable0[i]+"\t");

	}

	System.out.println();

	for(int i = 0; i<=10; i++){

	    System.out.print(positionTransTable[i]+"\t");

	}

	System.out.println();

	for(int i = 0; i <= 10; i++){

	    if(positionTransTable[i] != positionTransTable0[i]){

		int role = roleStringToInt(posTable.role[formation_type][i]);

		ms.addMessage("(Chpos "
			      +positionTransTable[i]
			      +" "+role
                              +" "+startPos[positionTransTable0[i]-1][0]
			      +" "+startPos[positionTransTable0[i]-1][1]
			      +" "+pos[positionTransTable0[i]-1][0]
			      +" "+pos[positionTransTable0[i]-1][1]
			      +")");
	    }
			      

	}

	for (int i = 0; i <= 10; i++){

	    positionTransTable0[i] = positionTransTable[i];

	}

    }

    protected int roleStringToInt(String role){

	int ret = 0;
	
	if(role.equals("GK")){
	    
	    ret = 1;

	}else if(role.equals("DF")){
	    
	    ret = 2;

	}else if(role.equals("MF")){

	    ret = 3;

	}else if(role.equals("OH")){

	    ret = 4;

	}else if(role.equals("FW")){

	    ret = 5;

	}else {

	    new IllegalArgumentException();

	}

	return ret;

    }

    protected boolean canMoveCommand(int play_mode){

	if ((play_mode == CParam.GOAL_L) ||
	    (play_mode == CParam.GOAL_R) ||
	    (play_mode == CParam.BEFORE_KICK_OFF)){
	    
	    return true;

	}else{

	    return false;
	    
	}

    }

}



