/*-------------------------------------------------------------------------*/
/*      GoalAnalyzer.java                                                  */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*              ʬϤ륯饹            */
/*                                                  */
/****************************************************/

package Analyzer;

//jdk packege
import java.util.*;

//my package
import Information.*;
import Utility.*;

public class GoalAnalyzer extends Analyzer{
    
    /*************************************************/
    /*                  teisuu                       */
    /*************************************************/

    private static final boolean VERBOSE = true;

    /*************************************************/
    /*          instance variable                    */
    /*************************************************/
 
    //PlayModeAnalyzer pma;
    KickAnalyzer ka;
    BaseSeeInformation bsi;

    //ǡ
    Vector goalVector;

    public int play_mode;
        
	/*********************************************/
	/*               constructor                 */
	/*********************************************/
	
	public GoalAnalyzer(BaseSeeInformation bsi, PlayModeAnalyzer pma, KickAnalyzer ka){

	        this.bsi= bsi;
		this.ka = ka;
		pma.addObserver(this);

		goalVector = new Vector();

	}		

	/***********************************************/
	/*                method                       */
	/***********************************************/

	public Vector getGoalVector(){

		return goalVector;

	}

    public void update(Observable o, Object arg){

	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer p = (PlayModeAnalyzer)o;
	    int mode = p.getCurrentPlayMode();

	    if (mode == CParam.GOAL_L || mode == CParam.GOAL_R){
		
		play_mode = mode;

		analyze();

	    }
	}

    }

    public void analyze(){

	Goal goal;
	Kick kick   = (Kick)(ka.getKickVector().lastElement());			
	int side    = kick.getSide();
        boolean isNoOwnGoal;

	/*ޤ
	if (play_mode == CParam.GOAL_L){
	    side = Team.LEFT;
	}else if (play_mode == CParam.GOAL_R){
	    side = Team.RIGHT;
	}else{
	    new IllegalArgumentException();
	}
	*/

	if ( ((play_mode == CParam.GOAL_L) && (side == Team.LEFT)) ||
             ((play_mode == CParam.GOAL_R) && (side == Team.RIGHT))) {

	    //own goalǤϤʤȤν
	    goal = new Goal(kick.getMember(), side, bsi.time, true);
	    goalVector.addElement(goal);

	}else{

	    //own goalΤȤν
	    goal = new Goal(kick.getMember(), side, bsi.time, false);
	    goalVector.addElement(goal);

	}

	setChanged();
	notifyObservers(goal);
	
	if (VERBOSE){
	
	    System.out.println("goal "+goal.getMember()+"no_own "+goal.isNoOwnGoal());

	}

    }

    public int getPlayerGoal(int unum, int side){

	int goal = 0;

	Enumeration enu = goalVector.elements();

	while(enu.hasMoreElements()){

	    Goal g = (Goal)enu.nextElement();

	    if (g.getMember() == unum && g.getSide() == side){
			
		goal++;				
	    }
	}

	return goal;

    }

}


 
