/*-------------------------------------------------------------------------*/
/*      GoalieMissAnalyzer.java                                            */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*                                                  */
/*                                                  */
/****************************************************/
package Analyzer;

//jdk packege
import java.util.*;

//my package
import Information.*;
import Utility.*;

public class GoalieMissAnalyzer extends Analyzer{
	
	/*************************************************/
	/*                  teisuu                       */
	/*************************************************/

	/*************************************************/
	/*          instance variable                    */
	/*************************************************/
 
        BaseSeeInformation bsi;
        KickAnalyzer ka;
	
        Vector kickVector;

	//ǡ
        public int goalieMiss = 0;

    int level = 0;
    int level3KickNum = -1;
        
	/*********************************************/
	/*               constructor                 */
	/*********************************************/
	
	public GoalieMissAnalyzer(BaseSeeInformation bsi, KickAnalyzer ka, PlayModeAnalyzer pma){

		this.bsi = bsi;

		ka.addObserver(this);
		pma.addObserver(this);

	}		

	/***********************************************/
	/*                method                       */
	/***********************************************/

    public void update(Observable o, Object arg){

	System.out.println("level ="+level);

	if (o instanceof KickAnalyzer){

	    checkKick( (KickAnalyzer)o);

	}else if (o instanceof PlayModeAnalyzer){

	    checkPlayMode((PlayModeAnalyzer)o);

	}
    }

    protected void checkPlayMode(PlayModeAnalyzer pma){

	if (level == 0){

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		level = 1;

	    }

	}else if (level == 3){ 

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		if (pma.getCurrentPlayMode() == CParam.GOAL_R){

		    goalieMiss++;
		    System.out.println("goalie miss"+goalieMiss);

		}
	    }

	}
    }

    protected void checkKick(KickAnalyzer ka){

	if (level == 1 || level == 2 || level == 3){
	    
	    Kick k = (Kick)(ka.getKickVector().lastElement());

	    int member = k.getMember();
	    int side   = k.getSide();

	    if( (member == 1) && (side == Team.LEFT) && ( (level==1)||(level==2) )){
		level = 2;

	    }else if ( ((level==2) &&(side==Team.RIGHT))){
		
		level3KickNum = member;
		level= 3;

	    }else if ( (level==3) && (side==Team.RIGHT) && (level3KickNum == member)){

		//Τޤ

	    }else{

		level = 0;
		level3KickNum = -1;

	    }

	} 

    }
}


 
