/*-------------------------------------------------------------------------*/
/*      InterceptAnalyzer.java                                             */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*               ѥʬϤ륯饹                 */
/*                                                  */
/****************************************************/
package Analyzer;

//my package
import java.util.*;

//jdk packege
import Information.*;

//ѥɥ֥Ƚꤹ륯饹
public class InterceptAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ
    Vector interceptVector;

    //Ȥǡ
    Vector kickVector;

    boolean continuousPlay = false;

    /*********************************************/
    /*                                       */
    /*********************************************/

    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public InterceptAnalyzer(KickAnalyzer ka, PlayModeAnalyzer pma){

	ka.addObserver(this);
	pma.addObserver(this);

	this.kickVector = ka.getKickVector();
	
	interceptVector = new Vector();
    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public Vector getInterceptVector(){

	return interceptVector;

    }

    public void update(Observable o, Object arg){

	//play_modeѲ
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		continuousPlay =false;

	    }

	//kickѲ
	}else if (arg instanceof KickAnalyzer){

	    if (continuousPlay){

		analyze();

	    }else{

		continuousPlay = true;

	    }

	}
    }

    public void analyze(){
		
	int kickSize = kickVector.size(); 

	//ޤkick򣱲󤷤Ǥ롣
	if (kickSize == 1){

	    return;				
	
	}
		
	Kick beforeKick = (Kick)kickVector.elementAt(kickSize-2);	
	Kick thisKick   = (Kick)kickVector.elementAt(kickSize-1);

	if (thisKick.side != beforeKick.side){

	    Intercept inter = new Intercept(beforeKick.member , thisKick.member,
					   beforeKick.posX   , beforeKick.posY,
					   thisKick.posX , thisKick.posY,      
				           beforeKick.time   , thisKick.time,
				           thisKick.side);

	    interceptVector.addElement(inter);

	    setChanged();
	    notifyObservers(this);

	    if (true){
		System.out.println("Intercept "+thisKick.member 
				   +"  " + beforeKick.member+"kara");
		
	    }
	}
    }
	
    public int getPlayerIntercept(int unum, int side){

	int inter = 0;

	Enumeration enu = interceptVector.elements();

	while(enu.hasMoreElements()){

	    Intercept i = (Intercept)enu.nextElement();

	    if ((i.getIntercepterUnum() == unum) && (i.getIntercepterSide() == side)){

		inter++;
	    }
	}

	return inter;		


    }

    public int getTotalIntercept(int side){

	int inter = 0;

	Enumeration enu = interceptVector.elements();

	while(enu.hasMoreElements()){

	    Intercept i = (Intercept)enu.nextElement();

	    if (i.getIntercepterSide() == side){

		inter++;
	    }
	}

	return inter;		

    }
    
}


