/*-------------------------------------------------------------------------*/
/*      KickAnalyzer.java                                                  */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*   åȽ򤹤ݥ饹                     */
/*                                                    */ 
/******************************************************/
package Analyzer;

import Information.*;

import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

abstract class KickAnalyzer extends Analyzer{

    /**************************************/
    /*        instance variable           */
    /**************************************/

    BaseSeeInformation bsi;

    //ǡ
    Vector kickVector;

    //ǡѲɤ
    boolean kickChanged = false;

    //ܡ򥭥åɤ
    boolean catchBall = false;
	
    double ball_vx;
    double ball_vy;

    /**************************************/
    /*               teisuu               */
    /**************************************/
    
    public static boolean VERBOSE = false;

    /**************************************/
    /*           constructor              */
    /**************************************/

    public KickAnalyzer(BaseSeeInformation bsi){

	this.bsi = bsi;
	bsi.addObserver(this);
	kickVector = new Vector();

	//kickVector.addElement(new Kick(-1, 0, 0 ,0));

    }		


    /**************************************/
    /*         abstract method            */
    /**************************************/

    abstract void analyze();
    
    /**************************************/
    /*               method               */
    /**************************************/

    public Vector getKickVector(){

	return kickVector;
    }

    public Kick getLastKick(){

	return (Kick)kickVector.lastElement();

    }

    public double getBallVX(){

	return ball_vx;

    }

    public double getBallVY(){

	return ball_vy;

    }

    protected void setKickMember(int step, int member, int side){
			
	Kick kick = new Kick(member, side, bsi.time, 
			     bsi.team[side].player[member-1].x, 
			     bsi.team[side].player[member-1].y);
			
	kickVector.addElement(kick);

	if(VERBOSE){

	    System.out.println(member+ "kick");
		
	}

	setChanged();
	notifyObservers(this);

    }

    //ץ졼줿˸ƤӽФ
    public void update(Observable o, Object arg){

	analyze();

    }

    public boolean doCatchBall(){

	return catchBall;
    }

    public int getTotalKick(int side){

	int kick = 0;

	Enumeration enu = kickVector.elements();		

	while(enu.hasMoreElements()){
						
	    Kick k = (Kick)enu.nextElement();
		
	    if ( k.getSide() == side){

		kick ++;			
	
	    }

	}

	return kick;

    }

    public int getPlayerKick(int unum, int side){
	
	int kick = 0;

	Enumeration enu = kickVector.elements();

	while(enu.hasMoreElements()){

	    Kick k = (Kick)enu.nextElement();
	    
	    if ((k.getMember() == unum) && (k.getSide() == side)){
			
		kick ++;				

	    }

	}

	return kick;
			
    }

    // 1/2 ƤʤȤ
    protected double getDistanceFromPlayerToBall(PlayerInformation pi){

	double dist = (pi.x - bsi.ball.x) * (pi.y - bsi.ball.y);

	return dist;

    }




}




	






 
