/*-------------------------------------------------------------------------*/
/*      KickAnalyzerDontUseFlag.java                                       */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*       о󤫤饭åȽꤹ     */
/*                                      饹      */
/****************************************************/
package Analyzer;

import Information.*;
import Utility.*;

import java.io.*;
import java.util.*;

public class KickAnalyzerDontUseFlag extends KickAnalyzer{

    /***********************************************/
    /*              instance variable              */
    /***********************************************/

    double[][] playerX0 = new double[2][11];
    double[][] playerY0 = new double[2][11];

    double ballX0 ;
    double ballY0 ;

    double ballDist0, ballDist;

    double angle0, angle;

    boolean init = false;

    /******************************************/
    /*            constructor                 */
    /******************************************/
    public KickAnalyzerDontUseFlag(BaseSeeInformation bsi){

	super(bsi);

	ballDist = ballDist0 = 0;
	angle = angle0 = 0;
	
    }

    /******************************************/
    /*             methods                    */
    /******************************************/

    //ʬϤ򤹤Ȥ
    public void analyze(){

	if (init){

	    kickAnalyze();

	}else{

	    initKickAnalyze();

	}
	 
    }
   
    protected void kickAnalyze(){

	if (bsi.play_mode != CParam.PLAY_ON){
	 
	    BallInformation ball = bsi.ball;

	    ballX0 = ball.x;
	    ballY0 = ball.y;

	    for (int side = 0; side <= 1; side++){
		for (int unum = 0; unum <= 10; unum++){ 
		    
		    PlayerInformation player = bsi.team[side].player[unum];
		    playerX0[side][unum] = player.x;
		    playerY0[side][unum] = player.y;
		}
	    }

	    return;

	}

	int minBallDist = 10000;
	int kickMember = -1;
	int kickMemberSide = -1;
	
	double toBallDist;
	double toBallDist0;

	BallInformation ball = bsi.ball;

	boolean ballKicked = isBallKicked(ball.x, ballX0, ball.y, ballY0);
	//System.out.println("ball kicked?"+ballKicked);

	ball_vx = ball.x - ballX0;
       	ball_vy = ball.y - ballY0;

	//System.out.println("vx="+ball_vx+"vy="+ball_vy);
	
	PlayerInformation player;

	for (int side = 0; side <= 1; side++){

	    for (int unum = 0; unum <= 10; unum++){ 

		player = bsi.team[side].player[unum];

		if (player.enable != CParam.DISABLE){

		    toBallDist0 = Utility.getDistance(playerX0[side][unum], 
                                                     playerY0[side][unum], 
                                                     ballX0, ballY0);

		    //System.out.println("dist"+toBallDist);

		    toBallDist= Utility.getDistance(player.x, player.y, ball.x, ball.y);
		    
		    //System.out.println("dist0"+toBallDist0);
		    
		    playerX0[side][unum] = player.x;
		    playerY0[side][unum] = player.y;

		    //ܡȥץ졼ΰ֤Ѳˤ,
		    //åȽꤹ
		    //if ( toBallDist0 <= 1.885 && toBallDist > 1.885 && ballKicked){
		
		    if ( toBallDist0 <= 1.885 && ballKicked){

			if (toBallDist < minBallDist){

			    //åФ򤤤롣
			    kickMember = unum+1;
			    kickMemberSide = side;
			}
		    }
		}
	    }
	}
	

	if (bsi.play_mode != CParam.PLAY_ON){
	 
	    return;

	}

	if (kickMember != -1){
	    
	    setKickMember(bsi.time, kickMember, kickMemberSide);

	}

	ballX0 = ball.x;
	ballY0 = ball.y;

    }

    protected void initKickAnalyze(){

	BallInformation ball = bsi.ball;
	PlayerInformation player;

	ballX0 = ball.x;
	ballY0 = ball.y;

	for (int side = 0; side <= 1; side++){
	    for (int unum = 0; unum <= 10; unum++){ 
		    
		player = bsi.team[side].player[unum];

		playerX0[side][unum] = player.x;
		playerY0[side][unum] = player.y;

	    }
	}

	init = true;

    }

    protected boolean isBallKicked(double x1, double x2, double y1, double y2){
	//٤ΥܡѲǡܡ뤬å줿ȹͤ뤫

	int MIN_KAKUDO = 15;
 
	boolean kicked = false;

	double xx,yy;

	ballDist0 = ballDist;
	ballDist  = Utility.getDistance(x1, y1, x2, y2);
	
	xx = x2 - x1;
	yy = y2 - y1;

	angle0 = angle;
	angle = Math.atan2(xx, yy);

	bsi.ball.angle = angle;

	if (Math.abs(angle0 - angle) > (Math.PI/180 * MIN_KAKUDO) || (ballDist > ballDist0)){
	    kicked = true;
	}

	return kicked;

    }

    
}
