/*-------------------------------------------------------------------------*/
/*      KickAnalyzerUseFlag.java                                           */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*       о󤫤饭åȽꤹ     */
/*                                      饹      */
/****************************************************/
package Analyzer;

import Information.*;
import Utility.*;

public class KickAnalyzerUseFlag extends KickAnalyzer{

    /***********************************************/
    /*              instance variable              */
    /***********************************************/

    double ballX0;
    double ballY0;

    boolean init = false;

    /******************************************/
    /*            constructor                 */
    /*****************************************/
    public KickAnalyzerUseFlag(BaseSeeInformation bsi){

	super(bsi);

    }
    /******************************************/
    /*             methods                    */
    /******************************************/

    //ʬϤ򤹤Ȥ override
    public void analyze(){

	if(init){

	    kickAnalyze();

	}else{

	    initKickAnalyze();

	}
    }
 
    protected void initKickAnalyze(){

	BallInformation ball = bsi.ball;

	ballX0 = ball.x;
	ballY0 = ball.y;

	init = true;

    }

    protected void kickAnalyze(){

	//ץ졼Ǥʤʤ,åϥȤʤ
	if (bsi.play_mode != CParam.PLAY_ON){

            BallInformation ball = bsi.ball;
            ballX0 = ball.x;
            ballY0 = ball.y;  

	    return;

	}

	calcBallVelocity();

	//Ŭ礭
	double minBallDist = 100000;
	int kickMember = -1;
	int kickMemberSide = -1;

	kickChanged = false;
	catchBall = false;
	
	for (int i = 0; i <= 10; i++){
	    for(int j = 0; j <= 1; j++){ 

		PlayerInformation player = bsi.team[j].player[i];

		//åե饰Ѥ

		if ( (Utility.compBitOr(player.enable, CParam.KICK) && 
		      !Utility.compBitOr(player.enable, CParam.KICK_FAULT))){

		    /*
		      if ( (Utility.compBitOr(player.enable, CParam.KICK) && 
		      !Utility.compBitOr(player.enable, CParam.KICK_FAULT)) ||
		      (Utility.compBitOr(player.enable, CParam.CATCH) &&
		      !Utility.compBitOr(player.enable, CParam.CATCH_FAULT))){ 	    
		    */

		    //Ʊ˥å,ֶᤤץ졼䤬å
		    //ˤ롣

		    if (getDistanceFromPlayerToBall(player) < minBallDist){

		    //åФ򤤤롣
		  
			kickMember = i+1;
			kickMemberSide = j;
			
		    }

		}
		
	    }
	}

	if (kickMember != -1){
	    
	    setKickMember(bsi.time, kickMember, kickMemberSide);

	    //åʹߤΥץ졼Ϣ³	
	    //ai.pmAna.setContinuousPlay();

	}

    }

    protected void calcBallVelocity(){

        BallInformation ball = bsi.ball;

        ball_vx = ball.x - ballX0;
        ball_vy = ball.y - ballY0;

	ballX0 = ball.x;
	ballY0 = ball.y;

    }

}




	






 
