/*-------------------------------------------------------------------------*/
/*      OneTwoPassAnalyzer.java                                            */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/11/10                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*              1-2ѥʬϤ륯饹             */
/*                                                  */
/****************************************************/

package Analyzer;

//jdk packege
import java.util.*;

//my package
import Information.*;
import Utility.*;

public class OneTwoPassAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ
    Vector oneTwoPassVector;

    //Ȥǡ
    Vector passVector;
    PlayerLocationAnalyzer pla;

    //ܤΥѥ2ܤΥѥδ֥ץ졼Ϣ³ƤȤ뤫
    boolean continuousPlay = false;

    Pass firstPass;
    Pass secondPass;

    /*********************************************/
    /*                                       */
    /*********************************************/

    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public OneTwoPassAnalyzer(PassAnalyzer pa, InterceptAnalyzer ia, DribbleAnalyzer da,
                              PlayModeAnalyzer pma, PlayerLocationAnalyzer pla){

	pa.addObserver(this);
	ia.addObserver(this);
	da.addObserver(this);
	pma.addObserver(this);

	this.passVector = pa.getPassVector();

	//PlayerLocationAnalyzerϴѻɬפϤʤ
	this.pla        = pla;

	oneTwoPassVector = new Vector();

    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public Vector getOneTwoPassVector(){

	return oneTwoPassVector;

    }

    public void update(Observable o, Object arg){

	//play_modeѲ
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		continuousPlay =false;
		
	    }

	//kickѲ
	}else if (o instanceof InterceptAnalyzer){

	    continuousPlay = false;


	}else if((o instanceof DribbleAnalyzer) && (continuousPlay)){
	    
	    DribbleAnalyzer da = (DribbleAnalyzer)o;
	    
	    if (da.getCurrentDribbleDistance() >= DribbleAnalyzer.MIN_DRIBBLE_DISTANCE){

		continuousPlay = false;

	    }

	}else if (o instanceof PassAnalyzer){

	    if (firstPass == null){
		
		firstPass = (Pass)arg;

	    }else{

		secondPass = (Pass)arg;

	 	if(continuousPlay){
		    analyze();
		}	

		firstPass  = secondPass;
		continuousPlay = true;

	    }

	}

    }

    public void analyze(){

	if (firstPass.getPasserUnum() != secondPass.getReceiverUnum()){

                return;

	}

	boolean PLAYER_IN_KABEPASS_AREA = false;
	int oppSide;

	Triangle tri = new Triangle (firstPass.passX, firstPass.passY,
				     firstPass.recvX, firstPass.recvY,
				     secondPass.recvX, secondPass.recvY);

	if (firstPass.getSide() == Team.LEFT){

	    oppSide = Team.RIGHT;

	}else{
	    
	    oppSide = Team.LEFT;

	}
	    
	for (int i = firstPass.passTime; i < secondPass.recvTime; i++){

	    for(int j = 1; j <= 11; j++){

		DPoint dp = pla.getPlayerPoint(i, oppSide, j);

		if (dp != null){

		if (dp.x == DPoint.NO_INIT){


		}else{

		    double x = dp.x;
		    double y = dp.y;

		    PLAYER_IN_KABEPASS_AREA = tri.isInner(x,y);

		    if (PLAYER_IN_KABEPASS_AREA){

			break;

		    }

		}
		}
	    }
	}
	    
	if (PLAYER_IN_KABEPASS_AREA){

	    System.out.println("1-2pass");
	    
	    OneTwoPass otPass = new OneTwoPass(firstPass, secondPass);

	    oneTwoPassVector.add(otPass);

	    setChanged();
	    notifyObservers(this);

	}

    }
    

    /**********************************************/
    /*       Σѥιפ֤     */
    /**********************************************/
    public int getTotal(int side){
	
	int result = 0;

	Enumeration enu = oneTwoPassVector.elements();

	while(enu.hasMoreElements()){

	    Pass p = (Pass)((OneTwoPass)enu.nextElement()).pass1;
	    
	    if (side == p.getSide()){

		result++;
		
	    }

	}

	return result;

    }

}


