/*-------------------------------------------------------------------------*/
/*      OppAttackPatternAnalyzer.java                                      */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

package Analyzer;

//my package
import Information.*;
import Analyzer.*;

//jdk packege
import java.util.*;

public class OppAttackPatternAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ
    boolean makeLineForDribble = false;

    //եɤ10ʬ䤷Ƥɤ鹶줿Ĵ٤
    int[] split = new int[FIELD_SPLIT_NUM];


    int attackedByDribble = 0;
    int attackedByPass    = 0;

    //ɤȤϤޤߤƤ

    /*
    double minLineX;
    double maxLineX;
    double averageLineX;
    */

    double minLineXForDribble;
    double maxLineXForDribble;
    double averageLineXForDribble;

    //
    //ؤʤ礳Ǥ....
    //
    int   kickIndex = 0;
    int[] kickTime = new int[2];
    boolean[] boolMakedDefLine = new boolean[2];   
    double[] minLineX = new double[2];
    double[] maxLineX = new double[2];
    double[] averageLineX = new double[2];


    //Ȥǡ
    BaseSeeInformation bsi;
    FormationAnalyzer  fa;

    int numOfSideAttack = 0;
    int numOfIntermediateAttack = 0;
    int numOfCenterAttack = 0;

    boolean isLine = false;

    /*********************************************/
    /*                                       */
    /*********************************************/

    public static int SIDE_ATTACK         = 0;
    public static int INTERMEDIATE_ATTACK = 1;
    public static int CENTER_ATTACK       = 2;

    public static int[] MY_DEFENDERS;

    public static int    FIELD_SPLIT_NUM     = 10;           
    public static double FIELD_SPLIT_DIST    = CParam.PITCH_WIDTH / FIELD_SPLIT_NUM; 

    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public OppAttackPatternAnalyzer(BaseSeeInformation bsi, KickAnalyzer ka, DribbleAnalyzer da, PassAnalyzer pa){

	this.bsi = bsi;
	
	ka.addObserver(this);
	da.addObserver(this);
	pa.addObserver(this);

	for (int i = 0; i <= 1; i++){
	    
	    kickTime[i] = 0;
	    boolMakedDefLine[i] = false;   
	    minLineX[i] = 0;
	    maxLineX[i] = 0;
	    averageLineX[i] = 0;

	}

	for (int i = 0; i < FIELD_SPLIT_NUM; i++){

	    split[i] = 0;

	}

    }		

    /***********************************************/
    /*                method                       */

    /***********************************************/

    public void setFormationAnalyzer(FormationAnalyzer fa){
	
	this.fa = fa;
	MY_DEFENDERS = fa.getDefendersUnum();

    }

    public void update(Observable o, Object arg){

	MY_DEFENDERS = fa.getDefendersUnum();
       
	if (o instanceof DribbleAnalyzer){

	    int type = ((Integer)arg).intValue();

	    checkDribble( (DribbleAnalyzer)o, type);

	}else if (o instanceof PassAnalyzer){
	    
	    checkPass( (Pass)arg );

	}else if (o instanceof KickAnalyzer){

	    //åִ֤
	    checkKick();

	}

    }

    public int[] getOppAttackPattern(){

	return split;

    }

    public int getAttackedNumber(int i){

	return split[i];	

    }

    public int getOppPassAttackNumber(){

	return attackedByPass;

    }

    public int getOppDribbleAttackNumber(){

	return attackedByDribble;

    }



    public int getTotalAttacked(){

	int num = 0;

	for(int i = 0; i < split.length; i++){
	
		num += split[i];

	}
	
	return num;

    }

    protected void checkDribble(DribbleAnalyzer da, int type){

	Dribble d = da.getCurrentDribble();

	//̣LEFTʤΤ
	if (d.getSide() == Team.LEFT){

	    return;

	}
	
	if (type == DribbleAnalyzer.NEW_DRIBBLE){

	    makeLineForDribble = checkMyDefenseLineForDribble();
		
	}else if (type == DribbleAnalyzer.CONTINUAL_DRIBBLE){

	    if (makeLineForDribble){

		if(bsi.ball.x < minLineXForDribble){

		    attackedByDribble++;
		    System.out.println("dribble attack:"+attackedByDribble);

		    whereAttacked();

		}

	    }else{

		//makeLine = checkMyDefenseLine();
			
	    }

	}

    }

    protected void checkPass(Pass p){

	int time = p.getPassTime();
	int index = 0;

	boolean adaptKick = false;

	for (int i = 0; i <= 1; i++){

	    if (time == kickTime[i] && 	boolMakedDefLine[i]){ 

		adaptKick = true;
		index = i;
		break;

	    }
	}
	
	if (adaptKick){

	    if(bsi.ball.x < minLineX[index]){

		whereAttacked();
		attackedByPass++;
		System.out.println("pass attack:"+attackedByPass);

	    }

	}

    }

    //
    //ɤˤ줿
    //
    protected void whereAttacked(){

	//**********************************************//
	//ŨϤɤ鹶Ƥ                      //
	//**********************************************//

	makeLineForDribble = false;

	int index = (int)((bsi.ball.y + CParam.PITCH_WIDTH_HALF) / FIELD_SPLIT_DIST);

	if (index < 0){

	    System.out.println("something wrong????? index = 0");
	    index = 0;

	}else if (index >= FIELD_SPLIT_NUM){

	    System.out.println("something wrong????? index = "+(FIELD_SPLIT_NUM-1));
	    index = FIELD_SPLIT_NUM -1;

	}
 
	(split[index])++;

	for (int i = 0; i <= 4; i++)
	    System.out.println(split[index]+"attaked!!!!! "+index);

	setChanged();
	notifyObservers(new String("ATTACK"));

	/*
	if( (bsi.ball.y<=-17) || (bsi.ball.y>=17)){

	    numOfSideAttack++;

	    System.out.println("side attack!");

	}else if ((bsi.ball.y>=-7) || (bsi.ball.y<=7)){
 			    
	    numOfCenterAttack++;
	    for (int i = 0; i <= 10; i++)
	    System.out.println("center attack!");

	}else{

	    numOfIntermediateAttack++;
	    for (int i = 0; i <= 10; i++)
	    System.out.println("intermediate attack!");

	}
	*/

    }

    protected void checkKick(){

	kickTime[kickIndex] = bsi.time;
	boolMakedDefLine[kickIndex] = checkMyDefenseLine();

	kickIndex++;

	if (kickIndex >= 2){
	    kickIndex = 0;
	}
    }

    //
    //Υǥե󥹥饤ΩƤ뤫å
    //

    protected boolean checkMyDefenseLine(){


	boolean line;
	double maxPosX, minPosX, sumX;

	maxPosX = minPosX = sumX = bsi.team[Team.LEFT].player[MY_DEFENDERS[0]-1].x;

	Team myTeam = bsi.team[Team.LEFT];

	for (int i = 1; i < MY_DEFENDERS.length; i++){
	  
	    sumX += myTeam.player[MY_DEFENDERS[i]-1].x;
	    
	    if (maxPosX < myTeam.player[MY_DEFENDERS[i]-1].x){

		maxPosX = myTeam.player[MY_DEFENDERS[i]-1].x;

	    }else if (minPosX > myTeam.player[MY_DEFENDERS[i]-1].x){

		minPosX = myTeam.player[MY_DEFENDERS[i]-1].x;

	    }

	}

	//
	//ǥեXǤ,5mʤХ饤
	//ΩƤΤȹͤ
	//
	//if ( (maxPosX - minPosX <= 7.5) && (bsi.ball.x > minPosX)) {
	if ( (bsi.ball.x > minPosX)) {
	    line = true;
	    isLine = true;

	    averageLineX[kickIndex] = sumX / MY_DEFENDERS.length;
	    minLineX[kickIndex] = minPosX;
	    maxLineX[kickIndex] = maxPosX;
 
	}else{

	    line = false;
	    isLine = false;

	}

	//System.out.println("check line"+ line);

	setChanged();
	notifyObservers(new String("LINE"));

	return line;

    }

    protected boolean checkMyDefenseLineForDribble(){

	boolean line;
	double maxPosX, minPosX, sumX;

	maxPosX = minPosX = sumX = bsi.team[Team.LEFT].player[MY_DEFENDERS[0]-1].x;

	Team myTeam = bsi.team[Team.LEFT];

	for (int i = 1; i < MY_DEFENDERS.length; i++){
	  
	    sumX += myTeam.player[MY_DEFENDERS[i]-1].x;
	    
	    if (maxPosX < myTeam.player[MY_DEFENDERS[i]-1].x){

		maxPosX = myTeam.player[MY_DEFENDERS[i]-1].x;

	    }else if (minPosX > myTeam.player[MY_DEFENDERS[i]-1].x){

		minPosX = myTeam.player[MY_DEFENDERS[i]-1].x;

	    }

	}

	//
	//ǥեXǤ,5mʤХ饤
	//ΩƤΤȹͤ
	//
	//if ( (maxPosX - minPosX <= 7.5) && (bsi.ball.x > minPosX)) {
	if ( (bsi.ball.x > minPosX)) {
	    line = true;
	    isLine = true;

	    averageLineXForDribble = sumX / MY_DEFENDERS.length;
	    minLineXForDribble = minPosX;
	    maxLineXForDribble = maxPosX;
 
	}else{

	    line = false;
	    isLine = false;

	}

	System.out.println("check line"+ line);

	setChanged();
	notifyObservers(new String("LINE"));

	return line;

    }

    public boolean isMakeLine(){

	return isLine;

    }

}



