/****************************************************/
/*                                                  */
/*                                                  */
/****************************************************/
package Analyzer;

//my package
import java.util.*;
import java.awt.*;

//jdk packege
import Information.*;
import Utility.*;


public class OurGoalKickAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ


    //Ȥǡ
    BaseSeeInformation    bsi;
    PlayModeAnalyzer      pma;

    MessageSender ms;

    /*********************************************/
    /*                                       */
    /*********************************************/

    //
    //ѡưݥ
    //
    /*
    static DPoint[] preset = {new DPoint(-40,-16),
			      new DPoint(-40,-12),
			      new DPoint(-40, -8),
			      new DPoint(-40, -4),
			      new DPoint(-40,  0),
			      new DPoint(-40,  4),
			      new DPoint(-40,  8),
			      new DPoint(-40, 12),
			      new DPoint(-40,-16)};
    */

    static DPoint[] preset = {new DPoint(-40,-16),
			      new DPoint(-40,-12),
			      new DPoint(-40, -8),
			      new DPoint(-40,  8),
			      new DPoint(-40, 12),
			      new DPoint(-40,-16)};

/*
    
    static DPoint[] preset = {new DPoint(-40,-16),
			      new DPoint(-40,-12),
			      new DPoint(-40, -8),
			      new DPoint(-40, -4),
			      new DPoint(-40,  0),
			      new DPoint(-40,  4),
			      new DPoint(-40,  8),
			      new DPoint(-40, 12),
			      new DPoint(-40, 16),
			      new DPoint(-36,-16),
			      new DPoint(-36,-12),
			      new DPoint(-36, -8),
			      new DPoint(-36, -4),
			      new DPoint(-36,  0),
			      new DPoint(-36,  4),
			      new DPoint(-36,  8),
			      new DPoint(-36, 12),
			      new DPoint(-36,-16)};
  */  

    static DPoint[] preset2 = {new DPoint(-42, -12),
			     new DPoint(-42, 12)};


    static DPoint[] kpreset2 = {new DPoint(-30, -30),
				new DPoint(-30, 30)};

    static final int NO_VAL = -100;

    public static final boolean VERBOSE = false;
	
    //ѤåɸȤץ졼ؤκΥ
    public static final double  MAX_DIST = 25;


    StaminaAnalyzer sa;

    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public OurGoalKickAnalyzer(BaseSeeInformation bsi,
			       PlayModeAnalyzer   pma,
			       MessageSender       ms,
			       StaminaAnalyzer     sa){


	this.bsi = bsi;
	this.pma = pma; 
	this.ms  = ms;
	this.sa  = sa;

	pma.addObserver(this);

    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public void update(Observable o, Object arg){
       
	if (o instanceof PlayModeAnalyzer){
	    
	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;
	    
	    if(pma.getCurrentPlayMode() == CParam.FREE_KICK_L){ 

		if(checkFreeKickAfterCatch()){

		    analyzeGKFreeKick();


		}

	    }

	}


    }
    
    protected boolean checkFreeKickAfterCatch(){

	int maxIndex;
	double maxVal;

	//FreeKickGKܡ򥭥åǤ֤ˤ
	//CatchȤߤʤ
	//CParam(catch the ballɲ)ۤ褤

	double gkx = bsi.team[Team.LEFT].player[0].x;
	double gky = bsi.team[Team.LEFT].player[0].y;
	double  bx = bsi.ball.x;
	double  by = bsi.ball.y;

	boolean flag = false;
 
	if(Utility.getDistance(gkx, gky, bx, by) <= 3.885){

	    flag = true;

	}

	return flag;

    }

    protected void analyzeGKFreeKick(){
	
	//ѥФƥץ졼ؤɾ
	double[] val = new double[10*preset.length]; 
	double[] adist = new double[10*preset.length]; 

	double minVal;

	PlayerInformation player;

	//
	//ѥФץ졼䤬ŨΥƤΥɾͤ
	//
	for (int i = 0; i <= 9; i++){

	    player = bsi.team[Team.LEFT].player[i+1];

            val[i] = getMinDistToOppPlayer(player);

	    if(val[i] <= 3.0){

		val[i] = NO_VAL;

	    }

            //ߤʤʤͤˤäƤͤ
	    if(sa.isStaminaLack(i+1)){

		val[i] = NO_VAL;

	    }

	}

	//
	//ץ졼䤴Ȥɾͤ򥭡Ѥmoveȼ褦
	//ɾͤ򥳥ԡ
	// 
	for (int i = 0; i <= 9; i++){
	    for (int j = 0; j <= preset.length-1; j++){

		val[i+j*10]= val[i];		

	    }

	}

	//
	//ѥ̤䤹ɾͤ
	//
	for (int i = 0; i <= 9; i++){

	    player = bsi.team[Team.LEFT].player[i+1];

	    for (int j = 0; j <= preset.length-1; j++){

		double kx = preset[j].x;
		double ky = preset[j].y;

		double dist = Utility.getDistance(player.x, player.y, kx, ky);

		//
		//MAX_DISTʾεΥؤΥץ졼ؤϡȤɤʤȤߤʤ
		//åоݤȤʤ
		//
	        if(dist > MAX_DIST || player.x < -32.0){

		    val[i+j*10] = NO_VAL;

		}

		adist[i+j*10] = dist;

		//
		//ϤǤ
		//
		if(val[i+j*10] != NO_VAL){
		   
		    if(checkPassCource(player.x, player.y, kx, ky ,Math.toRadians(30))){

			val[i+j*10] = val[i+j*10] + 20;

			if(VERBOSE){

				System.out.println("iti"+j+"  player"+i+"pass cource 10m free");
				System.out.println(player.x+"\t"+player.y);

			}
		    }else if(checkPassCource(player.x, player.y, kx, ky ,Math.toRadians(25))){

			val[i+j*10] = val[i+j*10] + 10;

			if(VERBOSE){

			System.out.println("iti"+j+"  player"+i+"pass cource 4m free");
			System.out.println(player.x+"\t"+player.y);

			}

		    }else if (checkPassCource(player.x, player.y, kx, ky, Math.toRadians(20))){
		    
			val[i+j*10] = val[i+j*10] + 5;

			if(VERBOSE){

			System.out.println("iti"+j+"  player"+i+"pass cource 2m free"); 
			System.out.println(player.x+"\t"+player.y);

			}

		    }else if(checkPassCource(player.x, player.y, kx, ky, Math.toRadians(10))){

			val[i+j*10] = val[i+j*10] - 10;
			
			if(VERBOSE){

			System.out.println("iti"+j+"  player"+i+"pass cource 1m free"); 
			System.out.println(player.x+"\t"+player.y);

			}

		    }else{

			//
			//ѥ϶Ƥʤ
			//
			val[i+j*10] = NO_VAL;

			System.out.println("iti"+j+"  player"+i+"no pass cource"); 
		    }

		    //
		    //¦¦ؤΥѥϥ󥿡ץȤȴʤΤ
		    //ʤ

		    double katamuki = Math.abs((ky-player.y) / (kx-player.x));

		    System.out.println(katamuki);


		    if(val[i+j*10] != NO_VAL){

			if(katamuki > 0.3 && (((ky>0.0)&&(player.y<ky)) || ((ky<0)&&(player.y>ky)))){

			    if(VERBOSE){

				System.out.println("damedame");
			
			    }

			    val[i+j*10] = NO_VAL;
			
			}else{
		   
			    //Ȥˤۤ,
		    
			    val[i+j*10] += Math.abs(ky/8);
			}
		    }

		}
		
	    }

	}

	//
	//ɾͤФȤ˺ǹɾͤФ褤
	//

	int maxIndex = -1;
	double maxVal = NO_VAL;
	double minDist = 10000;
	for (int i = 0; i <= 10*preset.length-1; i++){

	    if (val[i] >  maxVal){
		
		maxIndex = i;
		maxVal   = val[i];
		minDist = adist[i];

	    }else if((val[i] == maxVal) && adist[i] < minDist){

                maxIndex = i;
                maxVal   = val[i];
                minDist = adist[i];

            }

	}

	System.out.println("maxVal="+maxVal+"maxIndex"+maxIndex);

	double x, y;


	//åȤʤ
	if (maxVal < 10){

       		int index1 = 0;

		double val2 = 0;
		double maxVal2 = NO_VAL;

		for (int i = 0; i <= 1; i++){
		
			double kx = kpreset2[i].x;
			double ky = kpreset2[i].y;

		    	val2 = getMinDistToOppPlayer(preset2[i].x, preset2[i].y)*3;

		    	if(checkPassCource(preset2[i].x, preset2[i].y, kx, ky ,Math.toRadians(25))){
				val2 = val2 + 15;

		        }else if(checkPassCource(preset2[i].x, preset2[i].y, kx, ky ,Math.toRadians(17))){

				val2 = val2 + 8;


		    	}else if (checkPassCource(preset2[i].x, preset2[i].y, kx, ky, Math.toRadians(12))){
		    		val2 = val2 + 4;

		   	 }else {

				val2 = val2 - 10;
			
		    	}

    		   	if(maxVal2 < val2){

				index1 = i;
				maxVal2 = val2;

			}
	
		}

		ms.addMessage("(GK "+preset2[index1].x+" "+preset2[index1].y+" "+kpreset2[index1].x+" "+kpreset2[index1].y+")");

	}else{

		x = (int)(bsi.team[Team.LEFT].player[maxIndex%10+1].x*10)/10.0;
		y = (int)(bsi.team[Team.LEFT].player[maxIndex%10+1].y*10)/10.0;

		ms.addMessage("(GK "+preset[maxIndex/10].x+" "+preset[maxIndex/10].y+" "+x+" "+y+")");

	}    

    }


    protected boolean checkPassCource(double px, double py, double kx, double ky, double rad){

	PlayerInformation oppPlayer;

	double theta;
	double distKtoP = Utility.getDistance(px, py, kx, ky);

	double x1,x2,y1,y2;
	
	boolean flag = true;

	theta = Math.atan2(-py+ky, px-kx);

	distKtoP = distKtoP * 1.25;

	double dist = distKtoP / Math.cos(rad);

	y1 = dist * Math.sin(theta+rad);
	y2 = dist * Math.sin(theta-rad);
	x1 = dist * Math.cos(theta+rad);
	x2 = dist * Math.cos(theta-rad);

	Triangle tri = new Triangle(x1,y1,x2,y2,kx,ky);

	for (int i = 0; i <= 10; i++){
	    
	    oppPlayer = bsi.team[Team.RIGHT].player[i];

	    if (tri.isInner(oppPlayer.x, oppPlayer.y)){
		    
		flag = false;
		i = 10;
		    
	    }

	}
	
	return flag;

    }

    //
    //player p˺ǤᤤŨץ졼ȤεΥ֤
    //
    protected double getMinDistToOppPlayer(PlayerInformation p){

        double px = p.x;
	double py = p.y;
	double oppX, oppY;
	
	double min = 10000;  //Ŭ礭

	double dist;

	for(int i = 0; i <= 10; i++){

	    oppX = bsi.team[Team.RIGHT].player[i].x;
	    oppY = bsi.team[Team.RIGHT].player[i].y;

	    dist = Utility.getDistance(px, py, oppX, oppY);

	    if (dist < min){
		
		min = dist;

	    }
	}

	return  min;

    } 



    //
    //x,y˺ǤᤤŨץ졼ȤεΥ֤
    //
    protected double getMinDistToOppPlayer(double x, double y){

        double px = x;
	double py = y;
	double oppX, oppY;
	
	double min = 10000;  //Ŭ礭

	double dist;

	for(int i = 0; i <= 10; i++){

	    oppX = bsi.team[Team.RIGHT].player[i].x;
	    oppY = bsi.team[Team.RIGHT].player[i].y;

	    dist = Utility.getDistance(px, py, oppX, oppY);

	    if (dist < min){
		
		min = dist;

	    }
	}

	return  min;

    } 

    //
    //ȾdistŨץ졼䤬¸ߤ뤫
    //
    protected boolean checkFreePlayer(PlayerInformation p, double dist){

	double px = p.x;
	double py = p.y;
	double oppX, oppY;
	double dist0;
	
	boolean flag = false;

	int i = 0;
	PlayerInformation oppPlayer;

	do{
	    
	     oppX = bsi.team[Team.RIGHT].player[i].x;
	     oppY = bsi.team[Team.RIGHT].player[i].y;
	     
	     dist0 = Utility.getDistance(px, py, oppX, oppY);

	     if(dist0 > dist){
		 
		 flag = true;
		 break;

	     }

	     i++;
	  
	}while(i <= 10);

	return flag;

    } 

    /* test version
    protected void analyzeGKFreeKick(){

	double playerX, playerY;
	playerX = playerY = 0.0;
	int index = 0;

	int value = -10000; //ɾ
	int tmpVal;


	//ɤΰ,ɤΥץ졼䤬
	for (int j = 0; j <= preset.length-1; j++){

	    double bx = preset[j].x;
	    double by = preset[j].y;

	    for (int i = 1; i <= 10; i++){
		
		double px = bsi.team[Team.LEFT].player[i].x;
		double py = bsi.team[Team.LEFT].player[i].y;

		tmpVal = (int)((1.0/Utility.getDistance(px,py,bx,by))*1000);

		System.out.println(tmpVal);

		if (tmpVal >  value && px > bx){

		    value = tmpVal;
		    playerX = px;
		    playerY = py;
		    index   = j;

		}
	    }

	}

	ms.addMessage("(GK "+preset[index].x+" "+preset[index].y+" "+playerX+" "+playerY+")");


    }
    */

    //
    //׻ƥ
    //
	/*

    public static void main(String str[]){

	double x1,x2,y1,y2;
	double mx,my,ox,oy;


	double theta = Math.toRadians(30.0);
	mx = 0; my = 0; ox = 10; oy = 10;
	double dist = Utility.getDistance(mx,my,ox,oy);

	
	y1 = my + dist / Math.cos(theta) ;
	y2 = oy - (y1 - oy);  
	x2 = mx + dist / Math.sin(theta) ;
	x1 = ox - (x2 - ox);
	System.out.println(theta);
	System.out.println(x1);
	System.out.println(y1);
	System.out.println(x2);
	System.out.println(y2);

    }
*/
    /*
    public static void main(String str[]){

	double x1,x2,y1,y2;
	double mx,my,ox,oy;

	double dist = 10;
	double theta;
	mx = -10; my = -10; ox = 10; oy = 10;

	theta = Math.atan2(ox-mx, oy-my);

	y1 = oy + dist * Math.sin(theta);
	y2 = oy - dist * Math.sin(theta);
	x1 = ox - dist * Math.cos(theta);
	x2 = ox + dist * Math.cos(theta);
	
	System.out.println(theta);
	System.out.println(x1);
	System.out.println(y1);
	System.out.println(x2);
	System.out.println(y2);

    }
    */


	public static void main(String arg[]){

	double px = 10;
	double py = -10;

	double kx = 0;
	double ky = 0;

		double rad = Math.toRadians(20.0);

		double theta;
		double distKtoP = Utility.getDistance(px, py, kx, ky);

		double x1,x2,y1,y2;
	
		boolean flag = true;


	theta = Math.atan2(-py+ky, px-kx);

	System.out.println(Math.toDegrees(theta));

	double dist = distKtoP / Math.cos(rad);
	//double dist = distKtoP;

	y1 = dist * Math.sin(theta+rad);
	y2 = dist * Math.sin(theta-rad);
	x1 = dist * Math.cos(theta+rad);
	x2 = dist * Math.cos(theta-rad);

	System.out.println(x1+"\t"+y1+"\t"+x2+"\t"+y2);

	}

}




