/*-------------------------------------------------------------------------*/
/*      PassAnalyzer.java                                                  */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*               ѥʬϤ륯饹                 */
/*                                                  */
/****************************************************/
package Analyzer;

//my package
import java.util.*;

//jdk packege
import Information.*;

//ѥɥ֥Ƚꤹ륯饹
public class PassAnalyzer extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ
    Vector passVector;

    //Ȥǡ
    Vector kickVector;

    boolean continuousPlay = false;

    /*********************************************/
    /*                                       */
    /*********************************************/

    //1m̤,ѥǧʤ

    public static final double MIN_PASS_DISTANCE = 1.0;

    public static boolean VERBOSE = true;
	
    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public PassAnalyzer(KickAnalyzer ka, PlayModeAnalyzer pma){

	ka.addObserver(this);
	pma.addObserver(this);

	this.kickVector = ka.getKickVector();
	
	passVector = new Vector();
    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public Vector getPassVector(){

	return passVector;

    }

    public void update(Observable o, Object arg){


	//play_modeѲ
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		continuousPlay =false;

	    }

	//kickѲ
	}else if (arg instanceof KickAnalyzer){

	    if (continuousPlay){

		analyze();

	    }else{

		continuousPlay = true;

	    }

	}
    }

    public void analyze(){
		
	int kickSize = kickVector.size(); 

	//ޤkick򣱲󤷤Ǥ롣
	if (kickSize == 1){

	    return;				
	
	}
		
	Kick beforeKick = (Kick)kickVector.elementAt(kickSize-2);	
	Kick thisKick   = (Kick)kickVector.elementAt(kickSize-1);		
	if ((thisKick.side == beforeKick.side) && (thisKick.member != beforeKick.member)){

	    double xx,yy,dist;

	    xx = beforeKick.posX - thisKick.posX;
	    yy = beforeKick.posY - thisKick.posY;

	    //Ƚ꤬mʤ餳ɬפʤ?
	    //dist = Math.sqrt(xx*xx + yy*yy);

	    dist = xx*xx + yy*yy;
	    //å֤mʾ夢ʤСѥǧ
	    if (dist >= MIN_PASS_DISTANCE){

		Pass pass = new Pass(beforeKick.member , thisKick.member,
					 beforeKick.posX   , beforeKick.posY,
					 thisKick.posX , thisKick.posY,      
				     beforeKick.time   , thisKick.time,
				     thisKick.side);

		passVector.addElement(pass);

		setChanged();
		notifyObservers(pass);       

		if (VERBOSE){
		    System.out.println("pass is success kicker:"+beforeKick.member+"  receiver:"+thisKick.member);
		}
		
	    }else{
	    
		/*ν(m̤ƱΥץ졼Τ󤾤ä)*/
		/*,ޤ̤                                          */
	    
		/*
		  //1mʲϥå
		  ai.dijestVector.addElement("Time "+thisKick.time + " ni "+ beforeKick.member + "kara" +thisKick.member +" he switch!");
		  ai.dijestScore += CDirector.PASS_EVAL;
		*/
	    }
	}
    
    }
	
    public int getPlayerPass(int unum, int side){

	int pass = 0;

	Enumeration enu = passVector.elements();

	while(enu.hasMoreElements()){

	    Pass p = (Pass)enu.nextElement();

	    if ((p.getPasserUnum() == unum) && (p.getSide() == side)){

		pass++;
	    }
	}

	return pass;		


    }

    public int getTotalPass(short side){

	int pass = 0;

	Enumeration enu = passVector.elements();

	while(enu.hasMoreElements()){

	    Pass p = (Pass)enu.nextElement();

	    if (p.getSide() == side){

		pass++;
	    }
	}

	return pass;		


    }

    public int getPlayerPass(int unum, int to, int side){

	int pass = 0;

	Enumeration enu = passVector.elements();

	while(enu.hasMoreElements()){

	    Pass p = (Pass)enu.nextElement();

	    if (p.getPasserUnum() == unum && p.getReceiverUnum() == to
                                    && p.getSide() == side){

		pass++;
	    }
	}

	return pass;		

    }


    public int getPlayerPassReceive(int unum, int from, int side){
	
	int receive = 0;

	Enumeration enu = passVector.elements();

	while(enu.hasMoreElements()){

	    Pass p = (Pass)enu.nextElement();

	    if (p.getReceiverUnum() == unum && p.getPasserUnum() == from
                             && p.getSide() == side){
			
		receive++;				
	    }
	}

	return receive;

    }

    
    public int getTotalPlayerPassReceive(int unum, int side){

	int receive = 0;

	Enumeration enu = passVector.elements();

        while(enu.hasMoreElements()){

	    Pass p = (Pass)enu.nextElement();

	    //System.out.println("receive unum "+p.getIntercepterUnum());

	    if (p.getReceiverUnum() == unum && p.getSide() == side){

		receive++;

	    }
	

	}
	return receive;

    }

    
    
}


