/*-------------------------------------------------------------------------*/
/*      PlayModeAnalyzer.java                                              */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*       play_modeѲȽꤹ륯饹            */
/*                                                  */
/****************************************************/
package Analyzer;

//my package
import java.util.*;

//jdk packege
import Information.*;

public class PlayModeAnalyzer extends Analyzer{
	
    /***********************************************************/
    /*                         teisuu                          */
    /***********************************************************/
    
    public static final int PLAY_ON_TO_OFF  = 1;
    public static final int PLAY_OFF_TO_ON  = 2;
    public static final int PLAY_ON_TO_ON   = 3;
    public static final int PLAY_OFF_TO_OFF = 4;
	
    /***********************************************************/
    /*                  instance variable                      */
    /***********************************************************/

    BaseSeeInformation bsi;


    Vector goalVector;

    int offSideL = 0;
    int offSideR = 0;
    int cornerKickL = 0;
    int cornerKickR = 0;
    int goalieCatchL = 0;
    int goalieCatchR = 0;
    
    int playMode = CParam.BEFORE_KICK_OFF;
	
    int playModeFlow;

    //ץ졼⡼ɤǼ٥
    PlayModeVector pmVect = new PlayModeVector(); 

    /********************************************/
    /*            constructor                   */
    /********************************************/

    public PlayModeAnalyzer(BaseSeeInformation bsi){

	this.bsi = bsi;

    }		

    /********************************************/
    /*                 method                   */
    /********************************************/

    public int getPlayMode(){

	return playMode;

    }

    public Vector getGoalVector(){

	return goalVector;

    }

    public PlayModeVector getPlayModeVector(){

	return pmVect;
    }

    public void analyze(){
		
	if (bsi.play_mode != playMode){

	    //System.out.println(bsi.play_mode);

	    //ץ졼⡼ɤѲ

	    pmVect.add(new PlayMode(playMode, bsi.time));

	    if((playMode == CParam.PLAY_ON) && (bsi.play_mode != CParam.PLAY_ON)){

		playModeFlow = PLAY_ON_TO_OFF;
		playMode = bsi.play_mode;
		setChanged();
		notifyObservers(this);

		//System.out.println("PLAY_ON_TO_OFF!");

	    }else if ((playMode != CParam.PLAY_ON) && (bsi.play_mode ==CParam.PLAY_ON)){
		playModeFlow = PLAY_OFF_TO_ON;
		playMode = bsi.play_mode;
		setChanged();
		notifyObservers(this);
		
		//System.out.println("PLAY_OFF_TO_ON!");

	    }else{

		playModeFlow = PLAY_OFF_TO_OFF;
		playMode = bsi.play_mode;
		setChanged();
		notifyObservers(this);

	    }

	}
    }

    public int getInformation(){

	return playModeFlow;

    }

    public int getCurrentPlayMode(){

	return playMode;

    }
    
    public void update(Observable o, Object arg){

	analyze();

    }

}


	


 
