/*-------------------------------------------------------------------------*/
/*      PlayerLocationAnalyzer.java                                        */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/**************************************************************/
/*   playerΰ֤ϿƤ,distance׻????  */
/*                                                            */ 
/**************************************************************/
package Analyzer;

//my package
import Information.*;
import Utility.*;

//jdk package 
import java.util.*;

public class PlayerLocationAnalyzer extends Analyzer{

    /**************************************/
    /*        instance variable           */
    /**************************************/
    
    BaseSeeInformation bsi;

    //ץ졼䤬äΥ [side][unum-1] 
    double playerDistance[][] = new double[2][11];
    double playerSpeed[][]    = new double[2][11];
    //줳Υץ졼ΰ;
    AllPlayerPoint pp = new AllPlayerPoint(); 

    //ץ졼ΰ֤Ͽ
    //Vector???
    static final int MAX_ARRAY = 10000; 
    AllPlayerPoint[] playerPoints = new AllPlayerPoint[MAX_ARRAY];

    boolean init = false;
	
    int time;

    /**************************************/
    /*            constructor             */
    /**************************************/

    public PlayerLocationAnalyzer(BaseSeeInformation bsi){

	this.bsi = bsi;
	bsi.addObserver(this);

    }		

    /**************************************/
    /*               method               */
    /**************************************/

    public double getDistance(int side, int unum){

	return playerDistance[side][unum-1];

    }	

    public DPoint getPlayerPoint(int time, int side, int unum){

	//System.out.println("time"+time);

	if(playerPoints[time] == null){

		return null;

	}

	AllPlayerPoint app = playerPoints[time];

	return app.dp[side][unum-1];

    }

    public void update(Observable o, Object arg){

	analyze();
	setChanged();
	notifyObservers();

    }

    public void analyze(){
	
	if (!init){

	    init();

	}



	if (bsi.play_mode == CParam.PLAY_ON){

	    calcDistance();

	}

	copy();

	if (time != bsi.time){

	    copy2();

	}

	time = bsi.time;

    }

    protected void calcDistance(){

	//ưΥ׻
	for (int i = 0; i <= 1; i++){
	    for (int j = 0; j <= 10; j++){

		double xx = bsi.team[i].player[j].x - pp.dp[i][j].x; 
		double yy = bsi.team[i].player[j].y - pp.dp[i][j].y;

		double dist = Math.sqrt(xx*xx + yy*yy);
		
		playerDistance[i][j] += dist;
		playerSpeed[i][j]     = dist;

		//System.out.print("spped"+dist);
	
	    }

	}	

	//System.out.println();

    }

    protected void init(){

	copy();
	time = bsi.time;
	init = true;
    }

    protected void copy(){

	for (int i = 0; i <= 1; i++){
	    for (int j = 0; j <= 10; j++){
		pp.dp[i][j].x = bsi.team[i].player[j].x ;
		pp.dp[i][j].y = bsi.team[i].player[j].y;

	    }
	}
	
    }

    protected void copy2(){

	AllPlayerPoint ap = new AllPlayerPoint();

	for (int i = 0; i <= 1; i++){
	    for (int j = 0; j <= 10; j++){

		if (bsi.team[i].player[j].enable != CParam.DISABLE){

		    ap.dp[i][j].x = bsi.team[i].player[j].x;
		    ap.dp[i][j].y = bsi.team[i].player[j].y;

		}

	    }
	}

	playerPoints[bsi.time] = ap;
		
	//System.out.println("create"+bsi.time);

    }

    public double getToBallDistance(int side, int unum){

	return Utility.getDistance(bsi.team[side].player[unum-1].x, 
				   bsi.team[side].player[unum-1].y,
				   bsi.ball.x,
	                           bsi.ball.y); 

    }

    public double getSpeed(int side, int unum){

	return playerSpeed[side][unum-1];

    }

    public double getDegAngleToBall(int side, int unum){

	PlayerInformation player = bsi.team[side].player[unum-1];

	double angle = Utility.RADIAN * Math.atan2(bsi.ball.y - player.y, 
						   bsi.ball.x - player.x);

	return angle;	
    }

    //饹ʤ饹??????
    protected class AllPlayerPoint{

	public DPoint[][] dp;

	/**************************************/
	/*         󤹤Ȥ餯             */
	/**************************************/
	AllPlayerPoint(){

	    dp = new DPoint[2][11]; 

	    for(int i = 0; i <= 1; i++){
		for(int j = 0; j <= 10; j++){
		    
		    dp[i][j] = new DPoint();

		}
	    } 
	}
 

   }

}
