/*-------------------------------------------------------------------------*/
/*      PosPercentageAnalyzer.java                                         */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/10/22                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*                ΨʬϤ륯饹            */
/*                                                  */
/****************************************************/

package Analyzer;

//jdk packege
import java.util.*;

//my package
import Information.*;
import Utility.*;

public class PosPercentageAnalyzer extends Analyzer{
	
	/*************************************************/
	/*                  teisuu                       */
	/*************************************************/

    public static final boolean VERBOSE = true;

	/*************************************************/
	/*          instance variable                    */
	/*************************************************/
 
        BaseSeeInformation bsi;
	
        Vector passVector ;
        Vector dribbleVector;

	//ǡ
        int[] posTime = new int[2];


	/*********************************************/
	/*               constructor                 */
	/*********************************************/
	
	public PosPercentageAnalyzer(PassAnalyzer pa, DribbleAnalyzer da){

		pa.addObserver(this);
		da.addObserver(this);

		this.dribbleVector = da.getDribbleVector();
		this.passVector    = pa.getPassVector();

		posTime[0] = posTime[1] = 0;
		
	}		

	/***********************************************/
	/*                method                       */
	/***********************************************/

    public double getPosPercentage(int side){

	if ((posTime[0] + posTime[1]) == 0){

	    return 0.5;

	}

	return (double)posTime[side] / ((double)posTime[0] + posTime[1]);

    }

    public void update(Observable o, Object arg){
 
	if (o instanceof PassAnalyzer){

	    Pass p = (Pass)passVector.lastElement();
	    
	    posTime[p.side] += (p.recvTime - p.passTime);

	    if (VERBOSE){
		System.out.println("shihai side:"+p.side+"time:"+posTime[p.side
		]);
	    }
	    
	}else if (o instanceof DribbleAnalyzer){
	    
	    Dribble d = (Dribble)dribbleVector.lastElement();

	    Vector v = d.getDribblePoints();

	    int dsize = v.size();
	    DribblePoint dp1 = (DribblePoint)v.elementAt(dsize-2);
	    DribblePoint dp2 = (DribblePoint)v.elementAt(dsize-1);

	    posTime[d.side] += (dp2.time - dp1.time);

	    if (VERBOSE){
		System.out.println("shihai side:"+d.side+"time:"+posTime[d.side]);
		
	    }
	
	}

	setChanged();
	notifyObservers();

    }

    public void analyze(){

    }
    
}


 
