/*-------------------------------------------------------------------------*/
/*      ShootAnalyzer.java                                                 */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*              塼ȤʬϤ륯饹            */
/*                                                  */
/****************************************************/

package Analyzer;

//jdk packege
import java.util.*;

//my package
import Information.*;
import Utility.*;

public class ShootAnalyzer extends Analyzer{
	
	/*************************************************/
	/*                  teisuu                       */
	/*************************************************/

        //åƤ鲿simulation timeޤǤ,ãǤ
        //塼Ȥǧ뤫

        private static final int TIME = 20;
        private static final boolean VERBOSE = true;

	/*************************************************/
	/*          instance variable                    */
	/*************************************************/
 
        BaseSeeInformation bsi;
        KickAnalyzer ka;
	
        Vector kickVector;

	//ǡ
        Vector shootVector;
        
	/*********************************************/
	/*               constructor                 */
	/*********************************************/
	
	public ShootAnalyzer(BaseSeeInformation bsi, KickAnalyzer ka){

		this.bsi = bsi;

		ka.addObserver(this);

		shootVector = new Vector();

	        this.ka         = ka;
		this.kickVector = ka.getKickVector(); 

	}		

	/***********************************************/
	/*                method                       */
	/***********************************************/

	public Vector getShootVector(){

		return shootVector;

	}

    public void update(Observable o, Object arg){

	if (o instanceof KickAnalyzer){

	    analyze();

	}
    }

	public void analyze(){

		Kick thisKick   = (Kick)(kickVector.lastElement());						
		double angle = bsi.ball.angle;
		double vx, vy;

		double x,y,x0,y0;

		//ܡ®
		vx = ka.getBallVX();
		vy = ka.getBallVY();

		//System.out.println("vx="+vx+"vy="+vy);

		//ܡΰ
		x0 = x = bsi.ball.x;
		y0 = y = bsi.ball.y;

		//?øͽۤܡxɸ
		for (int i = 1; i <= TIME; i++){

		    vx = vx * CParam.BALL_DECAY;
		    vy = vy * CParam.BALL_DECAY;
		    x = x + vx;
		    y = y + vy;

		}
		
                double katamuki = 0;
		double a = 0;

		if ((x-x0) != 0.000000){
		    
		    katamuki = (y-y0) / (x-x0);
		    a        = katamuki * (-x) + y;

		}else{

		    //ܡΥ٥ȥηξ,
		    //塼ȤβǽϤʤ

		    System.out.println("katamuki = 0!!!");

		    return;

		}

		//System.out.println("x="+x);

		if (x >= CParam.PITCH_LENGTH_HALF){

		//饤ޤȤYɸ		    
                    double yy = katamuki * CParam.PITCH_LENGTH_HALF + a;

		    if (VERBOSE){
			
			System.out.println("location of across goal line ("+x+","+yy+")");
			
		    }
		    
 		    if ((yy <= 10) && (yy >= -10)){
			
			//饤ޤ֤
			//նʤΤǥǤ

			//󥷥塼ȡǤʤȽ

			if (thisKick.getSide() == Team.LEFT){
		
			    double diffX = (-thisKick.posX + CParam.PITCH_LENGTH_HALF);
			    double diffY = (thisKick.posY - yy);

			    double dist = Math.sqrt(diffX*diffX + diffY*diffY);

			    Shoot shoot = new Shoot(thisKick.getMember(), 
                                                    thisKick.getSide(),
						    bsi.time, 
                                                    thisKick.posX, 
                                                    thisKick.posY, 
						    dist);

			    shootVector.addElement(shoot);

			    setChanged();
			    notifyObservers(shoot);

			    if (VERBOSE){

				System.out.println("ShootR");

			    }

			}

		    }

		}else if (x <= -CParam.PITCH_LENGTH_HALF){

		    double yy        = katamuki * -CParam.PITCH_LENGTH_HALF + a;

		    if (VERBOSE){
			
			System.out.println("location of across goal line ("+x+","+yy+")");
			
		    }

		    if ((yy <= 10) && (yy >= -10)){

			//󥷥塼ȤǤʤȽ
			if (thisKick.getSide() == Team.RIGHT){

			    /*************************************/
			    /*  塼ȤȽꤵ줿Ȥν   */
			    /*************************************/
		
			    double diffX = (-thisKick.posX - CParam.PITCH_LENGTH_HALF);
			    double diffY = (thisKick.posY - yy);

			    double dist = Math.sqrt(diffX*diffX + diffY*diffY);

			    Shoot shoot = new Shoot(thisKick.getMember(), 
                                                    thisKick.getSide(),
						    bsi.time, 
                                                    thisKick.posX, 
                                                    thisKick.posY, 
						    dist);

			    shootVector.addElement(shoot);

			    setChanged();
			    notifyObservers(shoot);

			    if (VERBOSE){
			
				System.out.println("SHOOT L");
			    }
				 
			}
		    }
			    
		}
	}

    public int getPlayerShoot(int unum, int side){

	int shoot = 0;

	Enumeration enu = shootVector.elements();

	while(enu.hasMoreElements()){

			Shoot s = (Shoot)enu.nextElement();

			if (s.getMember() == unum && s.getSide() == side){
			
				shoot++;				
			}
	}

	return shoot;

    }

}


 





