/*-------------------------------------------------------------------------*/
/*      StaminaAnalyzer.java                                               */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/10/22                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*            ߥʤȽꤹ륯饹                */
/*                                                    */ 
/******************************************************/
package Analyzer;

import Information.*;

import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

public class StaminaAnalyzer extends Analyzer{

    /**************************************/
    /*        instance variable           */
    /**************************************/

    BaseSeeInformation bsi;
    PlayerLocationAnalyzer pla;

    boolean[] staminaLack = new boolean[11]; 
    int[]     counter     = new int[11];
    int[]     accuracy    = new int[11];
    int[]     permCounter = new int[11];
    /**************************************/
    /*               teisuu               */
    /**************************************/
    
    public static boolean VERBOSE = true;

    public static final int SIKIICHI = 15;

    /**************************************/
    /*           constructor              */
    /**************************************/

    public StaminaAnalyzer(BaseSeeInformation bsi, PlayerLocationAnalyzer pla){

	this.bsi = bsi;
 	this.pla = pla;
	pla.addObserver(this);

	for (int i = 0; i <= 10; i++){

		staminaLack[i] = false;
		counter[i]     = 0;
		permCounter[i] = 0;
		accuracy[i]       = 0;
	}

    }		
    public void analyze(){

	for (int i = 1; i <= 11; i++){

	    double speed = pla.getSpeed(Team.LEFT, i);
	    double angle = bsi.team[Team.LEFT].player[i-1].angle;
	    double angleToBall = pla.getDegAngleToBall(Team.LEFT, i);
	    double toBallDist  = pla.getToBallDistance(Team.LEFT, i);

	    /*
	    if(i == 4){

		System.out.println("keeper angle"+angle+"ball angle"+angleToBall+"speed"+speed+"toBallDist"+toBallDist);

	    }
            */

            double diff = angleToBall - angle;

            if(diff > 180){
                diff = 360 - diff;
            }else if(diff < -180){
                diff = 360 + diff;
 	    }
	
	    //Τ˥ԡѹΤ
            if((Math.abs(diff) < 30.0) && (speed <= 0.24) && (speed != 0.0) && (toBallDist <= 13)){
 
		counter[i-1]++;
		permCounter[i-1]++;
		accuracy[i-1]+=5;

            }else if( speed >= 0.5){

		//ߥʤ?
		counter[i-1] = 0;
		accuracy[i-1] = 0;


	    }else{

		if(accuracy[i-1] > 0){

		    accuracy[i-1] --;

		}

	    }
 
	    if (counter[i-1] >= SIKIICHI){

		if (VERBOSE){

		    System.out.println(i+"stamina lacked!!!(accuracy:"+accuracy[i-1]+")");

		}

 	    }
	}

    }

    /**************************************/
    /*               method               */
    /**************************************/
    //ץ졼줿˸ƤӽФ
    public void update(Observable o, Object arg){

	if (bsi.play_mode == CParam.PLAY_ON){

		analyze();

	}

    }

    public boolean isStaminaLack(int unum){

	if(counter[unum-1] >= SIKIICHI){

		return true;

	}else{

		return false;

	}

    }
    
    public int getStaminaLackNumber(int unum){

	return counter[unum-1];

    }
    
    public int getStaminaAccuracy(int unum){

	return accuracy[unum-1];

    }

    public void resetStamina(int unum){

	counter[unum-1] = 0;
	
    }

    public int getMostGenkiPlayer(){

	int min = 100000;
	int index = 1;

	for(int i = 2; i <= 11; i++){

	    if (getStaminaLackNumber(i) < min){

		min = getStaminaLackNumber(i);
		index = i;

	    }

	}

	return index;
    }
    
    public int getMostDamePlayer(){

	int max = -1;
	int index = 1;

	for(int i = 2; i <= 11; i++){

	    if (getStaminaLackNumber(i) > max && accuracy[i-1] > 0){

		max = getStaminaLackNumber(i);
		index = i;
	    }
	}

	return index;

    }
    
    public int getMostDameNumber(){

	int max = -1;
	int index = 1;

	for(int i = 2; i <= 11; i++){

	    if (getStaminaLackNumber(i) > max && accuracy[i-1] > 0){

		max = getStaminaLackNumber(i);
		index = i;
	    }
	}

	return max;

    }
}




	






 
