/*-------------------------------------------------------------------------*/
/*      StrategyRelayEvaluater.java                                        */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*                  άʬϥ饹                  */
/*                                                  */
/****************************************************/
package Analyzer;

//my package
import java.util.*;

//jdk packege
import Information.*;
import Strategy.*;
import Utility.*;

public class StrategyRelayEvaluater extends Analyzer{
	
    /*************************************************/
    /*            instance variable                  */
    /*************************************************/
    
    //ǡ
    Vector strategyVector;

    int currentStrategy = NO_STRAT;

    BaseStrategy bs;

    //Ȥǡ
    public BaseHearInformation bhi;
    public BaseSeeInformation  bsi;

    public KickAnalyzer ka;
    
    //åۤ륪֥
    MessageSender ms;
    
    /*********************************************/
    /*                                       */
    /*********************************************/
	
    public static final int NO_STRAT           = 0;
    public static final int STRAT_BALL_CLEAR   = 1;
    public static final int STRAT_COUNTER      = 2;
    public static final int STRAT_ONE_TWO_PASS = 3;
    public static final int STRAT_THROUGH_PASS = 4;

    /*********************************************/
    /*               constructor                 */
    /*********************************************/
	
    public StrategyRelayEvaluater(BaseHearInformation bhi, 
				  BaseSeeInformation  bsi,
				  GoalAnalyzer ga, 
			          ShootAnalyzer sa, OneTwoPassAnalyzer otpa, 
				  PlayModeAnalyzer pma, InterceptAnalyzer ia,
				  PassAnalyzer pa,
				  KickAnalyzer ka,
				  MessageSender ms){

	this.bhi = bhi;
	this.bsi = bsi;
	this.ka  = ka;
	this.ms  = ms; 

	ga.addObserver(this);
	sa.addObserver(this);
	otpa.addObserver(this);
        pma.addObserver(this);
	ia.addObserver(this);
	pa.addObserver(this);

	strategyVector = new Vector();

    }		

    /***********************************************/
    /*                method                       */
    /***********************************************/

    public Vector getStrategyVector(){

	return strategyVector;

    }

    public void update(Observable o, Object arg){
       
	if (currentStrategy != NO_STRAT){

	    //άˤ,ʤˤäȤĤ롣
	    if (BaseStrategy.END == bs.update(o, arg)){

		//⤷η̤άɾνλʤ,
		ms.addMessage(bs.getResult());
		currentStrategy = NO_STRAT;

	    }

	}

    }

    public void analyze(){

	int unum;
	String strategy;
	String type;

	//messageʬ
	StringTokenizer strtk = new StringTokenizer(bhi.message, " ()");

	for (int i = 1; i <= 4; i++){
	    strtk.nextToken();
	}

	//ȯץ졼ֹ
	unum = new Integer(strtk.nextToken()).intValue();

	while(strtk.hasMoreTokens()){

	    if(strtk.nextToken().equals("strategy")){

		//intercepted = false;

		strategy = strtk.nextToken();
		
		strtk.nextToken();

		type = strtk.nextToken();

		if(currentStrategy != NO_STRAT && (type.equals("plan") || 
						      type.equals("show"))){

		    //***************************************************
		    //⤷άȯץ졼,Υץ졼Ʊ
		    //άðȯ줿
		    //
		    //⤷,άðȯ줿
		    //ʤ,άϥ󥻥뤵Τ
		    //ͤ
		    //***************************************************
		    if(((bs.getUnum() == unum) && (bsi.time - bs.getTime() <= 2)) || (bsi.time - bs.getTime() <= 1 )){
			
			currentStrategyCancel();

		    }


		    PlayerInformation  player = bsi.team[Team.LEFT].player[unum-1];
		    BallInformation   ball   = bsi.ball;

		    double toBallDist= Utility.getDistance(player.x, 
							   player.y,
							   ball.x, ball.y);

		    //*************************************************
		    //άȯưȤ,Υץ졼䤬ܡ򽳤
		    //֤ˤʤ,ܡ򥭥åȹͤ
		    //*************************************************
		    if ( toBallDist <= 1.885){
			
			System.out.println ("fixed!!");
			ka.setKickMember(bsi.time, unum, Team.LEFT);
			
		    }


		    System.out.println("stragegy is said!");
		
		    bs.evaluate(strategy);
		    ms.addMessage(bs.getResult());
		    currentStrategy = NO_STRAT;

		}

		//
		//,餷줿άν
		//򤹤롣
		//

		//privateɾʤ
		if (strategy.equals("private") || type.equals("reply")){
		    
		    break;

		}else if (strategy.equals("ballClear")){

		    bs = new BallClearStrategy(bhi.time, unum, this, strategy);
		    currentStrategy = STRAT_BALL_CLEAR;
		    strategyVector.addElement(bs);
		    break;

		}else if(strategy.equals("counter")){

		    bs = new CounterStrategy(bhi.time, unum, this, strategy);
		    currentStrategy = STRAT_COUNTER;
		    strategyVector.addElement(bs);
		    break;

		}else if(strategy.equals("1-2Return")){

		    bs = new OneTwoReturnStrategy(bhi.time, unum, this, strategy);
		    currentStrategy = STRAT_ONE_TWO_PASS;
		    strategyVector.addElement(bs);
		    break;

		}else if (strategy.equals("throughPass")){

		    bs = new ThroughPassStrategy(bhi.time, unum, this, strategy);
		    currentStrategy = STRAT_THROUGH_PASS;
		    strategyVector.addElement(bs);
		    break;

		}else{

		    System.out.println("not implemented");
		    currentStrategy = NO_STRAT;
		    break;

		}
   
	    } 
	}
    }
	
    //
    //󥻥뤵줿Τ,άɾϤʤ
    //
    protected void currentStrategyCancel(){
	
	System.out.println("stragegy is canceled");

	strategyVector.removeElementAt(strategyVector.size()-1);
	currentStrategy = NO_STRAT;
	
    }
    
}


