//
//
//
/******************************************************/
/*                                                    */
/*                                                    */
/******************************************************/

import Information.*;
import Interface.*;
import Analyzer.*;
import GUI.*;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.applet.*;

public class AppFrame extends Frame implements Runner, 
  GameControlPanelEventListener{

    /******************************************/
    /*         instance variable              */
    /******************************************/
  
    Applet parent;
    AppletInterface ai;

    FieldCanvas fc;
    GameControlPanel gcp;

    BaseSeeInformation bsi;

    int start, end;

    int type = 0;

    /******************************************/
    /*            constructor                 */
    /******************************************/

    public AppFrame(Applet parent){

      super();

      this.parent = parent;

      ai = new AppletInterface(parent, "test", this);

      bsi = ai.bsi;

    }
    public AppFrame(Applet parent, int type){

      super();

      this.type = type;
      this.parent = parent;

      ai = new AppletInterface(parent, "test", this);

      bsi = ai.bsi;
    }

    /******************************************/
    /*             method                     */
    /******************************************/
    public void init(){

        setLayout(new BorderLayout());

	if(type==0){
	    //$B%j%W%l%$$rI=<((B
	    fc = new FieldCanvas(bsi);
	    
	}else if (type==1){
	    //$B50@W$rI=<((B

	    fc = new FieldKisekiCanvas(bsi);
	}

	GameStatusPanel gsp = new GameStatusPanel(bsi);
	gsp.init();

	gcp = new GameControlPanel(this);
	gcp.init();

        add("Center",fc);
        add("North",gsp);
        add("South",gcp);

	setVisible(true);

	resize(350,350);

    }

  public void run(){
    
    try{

      if (bsi.time < start){

	return;

      }else if (bsi.time >= end){

	fc.terminate();
	ai.stop();
	

      }

      ai.bsi.setChanged();
      ai.bsi.notifyObservers();
	
      Thread.sleep(150);
	 
    }catch(InterruptedException e){
      
      e.printStackTrace();
      
      
    }
    
    
  }
    
  public void stopPushed(){};
  public void closePushed(){dispose();};
  public void pausePushed(){};
  public void restartPushed(){};

  public void start(String logname,int start, int end){

    this.start = start;
    this.end   = end;

    ai = new AppletInterface(parent, logname, this);
    ai.init();
    bsi = ai.bsi;

    init();

      try{
	Thread.sleep(500);
      }catch(Exception e){
	e.printStackTrace();
      }

      try{
	
	ai.skip(start * 318);
      }catch(IOException ie){
	ie.printStackTrace();
      }
      ai.start();

  } 

}








