/*-------------------------------------------------------------------------*/
/*      CoachMain.java                                                     */ 
/*      Copyright (C) 2000 by  Shinji Futamase [g95241@isc.chubu.ac.jp]    */
/*      Last Update 2000/10/22                                             */
/*-------------------------------------------------------------------------*/

//my package
import Information.*;
import Interface.*;
import Analyzer.*;
import GUI.*;

//jdk packege
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.*;

public class CoachMain extends CoachInterface {

    /******************************************/
    /*         instance variable              */
    /******************************************/

    //ʬϥ֥
    KickAnalyzerDontUseFlag ka;
    PlayModeAnalyzer        pma;
    PassAnalyzer            pa;
    OneTwoPassAnalyzer      otpa;
    InterceptAnalyzer       ia;
    DribbleAnalyzer         da;
    PlayerLocationAnalyzer  pla;
    ShootAnalyzer           sa;
    GoalAnalyzer            ga;

    PosPercentageAnalyzer   ppa;
    BallLocationAnalyzer    bla;

    OppAttackPatternAnalyzer oapa;
    StaminaAnalyzer          staa;    

    StrategyRelayEvaluater  sre;

    FormationAnalyzer  fa; 
    KeiseiGraph        kg;

    OppAttackStatus  oas;

    FieldCanvas  fc;

    OurGoalKickAnalyzer ogka;

    MessageSender          ms;

    Frame fMain,fOppAttack,fKeisei;

    int formation = 0;

    /******************************************/
    /*            constructor                 */
    /******************************************/
    public CoachMain(String host, int port, String myTeamName, int version){

	super(host, port, myTeamName, version);

    }

    public CoachMain(String host, int port, String myTeamName, int version, int formation){

	super(host, port, myTeamName, version);
	this.formation = formation;

    }


    /******************************************/
    /*             method                     */
    /******************************************/

    public void init(){
	
	super.init();

	//ʬϤ륪֥Ȥ
	ka  = new KickAnalyzerDontUseFlag(bsi);
	pma = new PlayModeAnalyzer(bsi);
	pla = new PlayerLocationAnalyzer(bsi);

	pa  = new PassAnalyzer(ka, pma);
	ia  = new InterceptAnalyzer(ka, pma);
	da  = new DribbleAnalyzer(ka, pma);
	otpa= new OneTwoPassAnalyzer(pa, ia, da, pma, pla);
	sa  = new ShootAnalyzer(bsi, ka);
	ga  = new GoalAnalyzer(bsi, pma, ka);

	ppa = new PosPercentageAnalyzer(pa, da);
	bla = new BallLocationAnalyzer(bsi);

	

	//ά졼ɾ֥
	//sre = new StrategyRelayEvaluater(bhi, bsi, ga, sa, otpa, pma, ia, pa, ka, ms);


	//
	// analyzerƱǤʤȤդ뤳ȡ
	//
	ms  = new MessageSender(this);

	//ե᡼ɾ֥
	staa   = new StaminaAnalyzer(bsi, pla);
	oapa = new OppAttackPatternAnalyzer(bsi, ka, da, pa);
	
	fa = new FormationAnalyzer(oapa, ms, bsi, pma, staa, formation);	
	oapa.setFormationAnalyzer(fa);

	kg = new KeiseiGraph(ppa, bla, bsi);
	
	oas = new OppAttackStatus(oapa, fa);

	ogka = new OurGoalKickAnalyzer(bsi, pma, ms, staa);

	fc = new FieldCanvas(bsi);

	
	fKeisei = new Frame();
	fKeisei.add(kg);
	fKeisei.setSize(kg.getPreffererdSize());
	fKeisei.setVisible(true);
	
	fMain = new Frame();
	fMain.add(fc);
	fMain.setVisible(true);

	fOppAttack = new Frame();
	fOppAttack.add(oas);
	fOppAttack.setVisible(true);


    }

    public void run(){

        retAck = true;

	while(true){

	    //Ȥꤢ,®٤ΤȤϹͤʤ
	    //thread,,ʬϤΣĤ˻Ѥ뤫ϡ
	    
	    try{

		int ret;
		int nextIndex = 0;
		/************************************************/
		/*             åʬ               */
		/************************************************/

		//åФåä
		String message = getMessageFromSoccerServer();

		//åɤ
		ret = cmp.parse(message);

		/************************************************/
		/* ɤåʬϥ֥Ȥ     */
		/* ѲäȤΤ                 */
		/************************************************/

		if (ret == CoachMessageParser.SEE){

		    //BaseSeeInformationѹ
		    bsi.setChanged();
		    bsi.notifyObservers(this);


		}else if (ret == CoachMessageParser.HEAR_REFEREE){

		    //observer patternˤ٤
		    //ʤ,ϤΤޤޤˤƤ롣
		    pma.analyze();

		}else if (ret == CoachMessageParser.HEAR_MY_TEAM){

		    //
	            // ά졼ʬϤԤ
	            //
		    //sre.analyze();

		}

		/**********************************************************/
		/*ʤɡ᥿ʬǤ֤Ƚꤹ*/
		/*                                                        */
		/**********************************************************/

		if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF){

		    ms.separateMessages();

		}			

		/*****************************************************/
		/*                message                      */
		/*****************************************************/

		//Хåեåʤ
		// drop ball part add 0622

		if (sendMessages.size() != 0 && 
		    bsi.play_mode != CParam.PLAY_ON && 
		    bsi.play_mode != CParam.DROP_BALL &&
		    retAck
                    ){

		    //0623A
		    //¦,եޥåȤν򤹤褦ˤ
		    //

		    send_info("(say ("+(String)sendMessages.firstElement()+"))");
		    nextIndex  = 0;
		    sendMessages.removeElementAt(0);

		    }
	    

	    }catch(EOFException e){
		//ºݤEOFException뤳ȤϤʤ
		e.printStackTrace();
	    }catch(IOException e){
		e.printStackTrace();
	    }
	    
	    try{
		
		//ŪGUIɽΤ
		kg.repaint();
		sleep(10);

	    }catch(InterruptedException e){

		e.printStackTrace();
	    }
	    
	}

    }

    /*******************************************/
    /*               main  method              */
    /*******************************************/
    public static void main(String args[]){

	String host       = "localhost";
	int    port       = 6002;
	String myTeamName = "Kakitsubata";
	int    version    = 6;
	int    formation  = 0;
	
	for (int i = 0; i < args.length; i+=2){

	    if (args[i].equals("-h")){

		if(args[i+1] != null){
		    host = args[i+1].trim();
		} else{
		    System.exit(1);
		}
	    }
	    else if (args[i].equals("-t")){

		if(args[i+1] != null){
		    myTeamName = args[i+1].trim();
		} else{
		    usage();
		    System.exit(1);
		}
	     }
	    else if (args[i].equals("-p")){

		if(args[i+1] != null){
		    port = new Integer(args[i+1].trim()).intValue();
		} else{
		    usage();
		    System.exit(1);
		}
	     }else if (args[i].equals("-v")){

		if(args[i+1] != null){
		    
		    version = new Integer(args[i+1].trim()).intValue();

		} else{
		    usage();
		    System.exit(1);
		}

	     }else if (args[i].equals("-f")){

		if(args[i+1] != null){

		    formation = new Integer(args[i+1].trim()).intValue();

		} else{
	
		    usage();
		    System.exit(1);
		}

	     }else{
		usage();
	        System.exit(1);
	    }
	}

	CoachMain cm = new CoachMain(host, port, myTeamName, version, formation);

	cm.init();

	cm.start();
		    
    }

    public static void usage(){

	System.out.println("usage:java CoachMain [option]");
	System.out.println("options");
	System.out.println("-h HOST      (default localhost)");
	System.out.println("-t TEAM_NAME (default Kakitsubata)");
	System.out.println("-p PORT      (default 6002)");
	System.out.println("-v VERSION   (default 6)");
	System.out.println("-f FORMATION (default 0)");

    }



}




