/*-------------------------------------------------------------------------*/
/*      FieldCanvas.java                                                   */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/
//
//
/******************************************************/
/*               եɤɽ륯饹           */
/*                                                    */
/******************************************************/

package GUI;

import Information.*;

import java.util.*;
import java.awt.*;

public class FieldCanvas extends Canvas implements Observer{
	 
  /*************************************************/
  /*              instance variable                */
  /*************************************************/

  //եɤɬפʤ
  Image buff = null ;
  Image backField = null;
  Graphics gbuff, gbf;
  
  int width, height;
	
  //static int length_magnify = (int)CParam.LENGTH_MAGNIFY_SMALL;	
  static int length_magnify = 3;	 

  //եɾΥ֥
  FieldObject fo1, fo2;

  /*************************************************/
  /*                 construnctor                  */
  /*************************************************/

    public FieldCanvas(){ 
    
    }
    public FieldCanvas(int length_magnify){

    this.length_magnify = length_magnify;	
    
    width =  InPitchSize(CParam.PITCH_LENGTH + 2 * CParam.PITCH_MARGIN) + 1;
    height = InPitchSize(CParam.PITCH_WIDTH + 2 * CParam.PITCH_MARGIN) + 1;
		
    resize(width, height);

    }	
    
  public FieldCanvas(BaseSeeInformation bsi){
			
    this(length_magnify, bsi);

  }
	
  public FieldCanvas(int length_magnify, BaseSeeInformation bsi) {

    length_magnify = length_magnify;	
    
    width =  InPitchSize(CParam.PITCH_LENGTH + 2 * CParam.PITCH_MARGIN) + 1;
    height = InPitchSize(CParam.PITCH_WIDTH + 2 * CParam.PITCH_MARGIN) + 1;
		
    resize(width, height);
    
    fo1 = new FieldPlayerObject(this, bsi);
    fo2 = new FieldBallObject(this, bsi);

    bsi.addObserver(this);

  }
	

  /*************************************************/
  /*                    method                     */
  /*************************************************/
  
  public void paint(Graphics g) {
		
    //System.out.println("called paint();");

    if (buff == null ) {                     
      buff = createImage(width, height);
      gbuff = buff.getGraphics();
      
    }
		
    if (backField == null) {
      backField = createImage(width, height);
      gbf = backField.getGraphics();
      drawField(gbf);

      gbuff.drawImage(backField,0,0,this);
    }		
	
    g.drawImage(buff ,0,0,this);

  }

  public void update(Graphics g){
    
    paint(g);
    
  }

  public void update(Observable o, Object arg){
				
    BaseSeeInformation bsi = (BaseSeeInformation)o;

    try{
      if ((gbuff == null) || (backField == null)){
	Thread.sleep(100);
	repaint();
	return;
      }
    }catch(Exception e){
      e.printStackTrace();
    }

    //System.out.println("call draw");

    gbuff.drawImage(backField,0,0,this);	
    fo1.draw();
    fo2.draw();
    repaint();

  }

  //طʤΥեɤХåե˽񤭽Ф
  public void drawBackField(){

    gbuff.drawImage(backField,0,0,this);			

  }	

  public void clearGraphicsBuffer(){

    buff = null;
    backField = null;
  }
  
  public Graphics getGraphicsBuffer(){
    
    return gbuff;

  }

  public void createGraphicsBuffer(){

    buff = createImage(width, height);
    gbuff = buff.getGraphics();

    backField = createImage(width, height);
    gbf = backField.getGraphics();
    drawField(gbf);

    gbuff.drawImage(backField,0,0,this);
  }
  
  //λν
  public void terminate(){


  }		
  //
  //äȤʤեɤ
  //
  protected void drawField(Graphics grf){

    double gwidth = 14.02;
    int degree ;// penalty arc degree
	
    degree = (int)CParam.RAD2DEG(Math.acos((CParam.PENALTY_AREA_LENGTH -
					CParam.PENALTY_SPOT_DIST) / CParam.CENTER_CIRCLE_R));
								
    /* margin */
    gbf.setColor(Color.orange.darker());
    gbf.fillRect(0, 0, 
	 InPitchSize(CParam.PITCH_LENGTH + 2 * CParam.PITCH_MARGIN) + 1, 
	 InPitchSize(CParam.PITCH_WIDTH + 2 * CParam.PITCH_MARGIN) + 1);

    /* field */
    gbf.setColor(Color.green.darker().darker());
    gbf.fillRect(
		 InFieldPosX(-CParam.PITCH_LENGTH/2.0), 
		 InFieldPosY(-CParam.PITCH_WIDTH/2.0), 
		 InPitchSize(CParam.PITCH_LENGTH),
		 InPitchSize(CParam.PITCH_WIDTH) );
    

    /* field line */
    gbf.setColor(Color.white);
    gbf.drawRect(
		 InFieldPosX(-CParam.PITCH_LENGTH/2.0), 
		 InFieldPosY(-CParam.PITCH_WIDTH/2.0), 
		 InPitchSize(CParam.PITCH_LENGTH),
		 InPitchSize(CParam.PITCH_WIDTH) );
    /* center line */
    gbf.drawLine(
		 InFieldPosX(0.0),InFieldPosY(-CParam.PITCH_WIDTH/2.0),
		 InFieldPosX(0.0),InFieldPosY(CParam.PITCH_WIDTH/2.0)) ; 
    /* left penalty area */
    gbf.drawRect(
		 InFieldPosX(-CParam.PITCH_LENGTH/2.0), 
		 InFieldPosY(-CParam.PENALTY_AREA_WIDTH/2.0), 
		 InPitchSize(CParam.PENALTY_AREA_LENGTH),
		 InPitchSize(CParam.PENALTY_AREA_WIDTH) );
    /* right penalty area */
    gbf.drawRect(
		 InFieldPosX(CParam.PITCH_LENGTH/2.0-CParam.PENALTY_AREA_LENGTH), 
		 InFieldPosY(-CParam.PENALTY_AREA_WIDTH/2.0), 
		 InPitchSize(CParam.PENALTY_AREA_LENGTH),
		 InPitchSize(CParam.PENALTY_AREA_WIDTH) );
    /* left goal area */
    gbf.drawRect(
		 InFieldPosX(-CParam.PITCH_LENGTH/2.0),
		 InFieldPosY(-CParam.GOAL_AREA_WIDTH/2.0),
		 InPitchSize(CParam.GOAL_AREA_LENGTH),
		 InPitchSize(CParam.GOAL_AREA_WIDTH)) ;
    /* right goal area */
    gbf.drawRect(
		 InFieldPosX(CParam.PITCH_LENGTH/2.0-CParam.GOAL_AREA_LENGTH),
		 InFieldPosY(-CParam.GOAL_AREA_WIDTH/2.0),
		 InPitchSize(CParam.GOAL_AREA_LENGTH),
		 InPitchSize(CParam.GOAL_AREA_WIDTH)) ;
    /* center circle */
    gbf.drawOval(
		 InFieldPosX(-CParam.CENTER_CIRCLE_R),
		 InFieldPosY(-CParam.CENTER_CIRCLE_R),
		 InPitchSize(CParam.CENTER_CIRCLE_R*2.0),
		 InPitchSize(CParam.CENTER_CIRCLE_R*2.0));
    /* left penalty arc */
    gbf.drawArc(
		InFieldPosX(-CParam.PITCH_LENGTH/2.0+CParam.PENALTY_SPOT_DIST -CParam.CENTER_CIRCLE_R) +2,
		InFieldPosY(-CParam.CENTER_CIRCLE_R),
		InPitchSize(CParam.CENTER_CIRCLE_R*2.0),
		InPitchSize(CParam.CENTER_CIRCLE_R*2.0), -degree , degree*2) ;
    /* right penalty arc */
    gbf.drawArc(
		InFieldPosX(CParam.PITCH_LENGTH/2.0-CParam.PENALTY_SPOT_DIST -CParam.CENTER_CIRCLE_R) +1,
		InFieldPosY(-CParam.CENTER_CIRCLE_R),
		InPitchSize(CParam.CENTER_CIRCLE_R*2.0),
		InPitchSize(CParam.CENTER_CIRCLE_R*2.0), (180-degree), degree*2) ;
    /* upper left corner arc */
    gbf.drawArc(
		InFieldPosX(-CParam.PITCH_LENGTH/2.0-CParam.CORNER_ARC_R),
		InFieldPosY(-CParam.PITCH_WIDTH/2.0-CParam.CORNER_ARC_R),
		InPitchSize(CParam.CORNER_ARC_R*2.0),
		InPitchSize(CParam.CORNER_ARC_R*2.0), -90, 90) ;
    /* upper right corner arc */
    gbf.drawArc(
		InFieldPosX(CParam.PITCH_LENGTH/2.0-CParam.CORNER_ARC_R),
		InFieldPosY(-CParam.PITCH_WIDTH/2.0-CParam.CORNER_ARC_R),
		InPitchSize(CParam.CORNER_ARC_R*2.0),
		InPitchSize(CParam.CORNER_ARC_R*2.0), 180, 90) ;
    /* lower left corner arc */
    gbf.drawArc(
		InFieldPosX(-CParam.PITCH_LENGTH/2.0-CParam.CORNER_ARC_R),
		InFieldPosY(CParam.PITCH_WIDTH/2.0-CParam.CORNER_ARC_R),
		InPitchSize(CParam.CORNER_ARC_R*2.0),
		InPitchSize(CParam.CORNER_ARC_R*2.0), 0, 90) ;
    /* lower right corner arc */
    gbf.drawArc(
		InFieldPosX(CParam.PITCH_LENGTH/2.0-CParam.CORNER_ARC_R),
		InFieldPosY(CParam.PITCH_WIDTH/2.0-CParam.CORNER_ARC_R),
		InPitchSize(CParam.CORNER_ARC_R*2.0),
		InPitchSize(CParam.CORNER_ARC_R*2.0), 90, 90) ;
    /* left side goal */
    gbf.setColor(Color.black);
    gbf.fillRect(
		 InFieldPosX(-CParam.PITCH_LENGTH/2.0-CParam.GOAL_DEPTH)+1,
		 InFieldPosY(-gwidth/2.0),
		 InPitchSize(CParam.GOAL_DEPTH)+1,
		 InPitchSize(gwidth)+1) ;
    /* right side goal */
    gbf.fillRect(
		 InFieldPosX(CParam.PITCH_LENGTH/2.0),
		 InFieldPosY(-gwidth/2.0),
		 InPitchSize(CParam.GOAL_DEPTH)+1,
		 InPitchSize(gwidth)+1);

    /*test you*/

    /*
    double diff = CParam.PITCH_WIDTH / 10 ;

    for (int i = 0; i <= 10; i++){

	gbf.drawLine(InFieldPosX(-CParam.PITCH_LENGTH/2.0),
		     InFieldPosY(-CParam.PITCH_WIDTH/2.0+diff*i),
		     InFieldPosX(CParam.PITCH_LENGTH/2.0),
		     InFieldPosY(-CParam.PITCH_WIDTH/2.0+diff*i));
    }    
    */


  }
  

//
//ϤեɤΥؽ
//

	public static final int InPitchSize(double l) { return (int)(l *  length_magnify) ;}
	public static final int InPitchPosX(double x) { return InPitchSize(x + CParam.PITCH_LENGTH/2.0) ;}
	public static final int InPitchPosY(double y) { return InPitchSize(y + CParam.PITCH_WIDTH/2.0) ;}
	public static final int InFieldPosX(double x) { return InPitchPosX(x + CParam.PITCH_MARGIN) ;}
	public static final int InFieldPosY(double y) { return InPitchPosY(y + CParam.PITCH_MARGIN) ;}
	public static final int InPitchPosX(short x) { return InPitchPosX((double)x);}
	public static final int InPitchPosY(short y) { return InPitchPosY((double)y);}
	public static final int InFieldPosX(short x) { return InFieldPosX((double)x);}
	public static final int InFieldPosY(short y) { return InFieldPosY((double)y);}
	public static final int InDisplaySize(double l) { return (InPitchSize(l*2.0)) ;}

  public static void main (String arg[]){

    Frame  f = new Frame();
    FieldCanvas c = new FieldCanvas(5);
    f.add(c);

    c.setVisible(true);
    f.setVisible(true);


  }

}

