/*-------------------------------------------------------------------------*/
/*      HoshinoFace.java                                                   */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

package GUI;

import Information.*;
import Analyzer.*;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

//
//keisei wo arawasu graph
//

public class HoshinoFace extends Canvas implements Observer{

    /******************************************/
    /*        instance  variable              */
    /******************************************/
    Image buff = null ;
    Image backField = null;
    Graphics gbuff, gbf;

    //canvas width ,height
    int width = 650;
    int height = 200;

    //graph width, height
    int gwidth = 300;
    int gheight = 200;

    int score;
    int time = 0;
   
    double SCALE_X = (double)gwidth / 6000;

    /*********************************************/
    /*            constructor                    */
    /*********************************************/

    public HoshinoFace(){
			
	//this(width,height);
  
	setSize(width, height);
	setBackground(Color.white);

    }

    public HoshinoFace(PosPercentageAnalyzer ppa){

	this();

	ppa.addObserver(this);

    }
		
    public HoshinoFace(int width, int height) {
	      
	this.width = width;
	this.height = height;

	setSize(width, height);
	setBackground(Color.white);

    } 
	
    /*******************************************/
    /*             method                      */
    /*******************************************/

    /************* override Canvas **************/   

    public void paint(Graphics g) {
	
	//System.out.println("called paint();");

	if (buff == null ) {                     
        
	    buff = createImage(width, height);
	    gbuff = buff.getGraphics();

	}
		
	if (backField == null) {
	    backField = createImage(width, height);
	    gbf = backField.getGraphics();
	    setBackField(gbf);

	    gbuff.drawImage(backField,0,0,this);
	}		
	
	g.drawImage(buff ,0,0,this);
    }

    public void update(Graphics g){

	paint(g);
	
    }

    /***************** override Observer *********************/
    public void update(Observable o, Object arg){
				
	if (o instanceof PosPercentageAnalyzer){

	    draw((PosPercentageAnalyzer)o);

	    repaint();

	}

    }
	
    /**********************************************************/	

    public void drawBackField(){

	gbuff.drawImage(backField,0,0,this);			
	
    }	

    public void clearGraphicsBuffer(){
	
	buff = null;
	backField = null;
    }

    public void createGraphicsBuffer(){

	buff = createImage(width, height);
	gbuff = buff.getGraphics();

	backField = createImage(width, height);
	gbf = backField.getGraphics();
	setBackField(gbf);

	gbuff.drawImage(backField,0,0,this);
    }

    private void setBackField(Graphics gb){

    }

    //override java.awt.Component 
    public Dimension getPreffererdSize(){

	return getSize();

    }    

    public void draw(PosPercentageAnalyzer pos){
	
	double pos_percent  = pos.getPosPercentage(Team.LEFT);

    }

    public static void main(String arg[]){

	Frame  f = new Frame();
	KeiseiGraph kg  = new KeiseiGraph();
	f.add(kg);

	f.setVisible(true);

    }

}


