/*-------------------------------------------------------------------------*/
/*      KeiseiGraph.java                                                   */ 
/*      Copyright (C) 2000 by  Sinji Futamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/10/22                                             */
/*-------------------------------------------------------------------------*/

//
//򤢤魯դΥ饹
//
package GUI;

import Information.*;
import Analyzer.*;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

//
//keisei wo arawasu graph
//

public class KeiseiGraph extends Canvas implements Observer{

    /******************************************/
    /*        instance  variable              */
    /******************************************/
    Image buff = null ;
    Image backField = null;
    Graphics gbuff, gbf;

    //canvas width ,height
    int width = 650;
    int height = 200;

    //graph width, height
    int gwidth = 300;
    int gheight = 200;

    int score;
    int time = 0;
    int time0 = 0;

    double SCALE_X = (double)gwidth / 6000;

    PosPercentageAnalyzer ppa;
    BallLocationAnalyzer  bla;
    
    double ball_pos;
    double ball_pos0;

    double pos_percent;
    double pos_percent0;

    BaseSeeInformation bsi;

    FormationAnalyzer fa;

    /*********************************************/
    /*            constructor                    */
    /*********************************************/

    public KeiseiGraph(){

        //this(width,height);

        setSize(width, height);
        setBackground(Color.white);

    }

    public KeiseiGraph(FormationAnalyzer fa){

        this();

        fa.addObserver(this);
	this.fa = fa;

    }

    public KeiseiGraph(int width, int height) {
              
        this.width = width;
        this.height = height;

        setSize(width, height);
        setBackground(Color.white);

    } 


    public KeiseiGraph(PosPercentageAnalyzer ppa, BallLocationAnalyzer bla,
	    	       BaseSeeInformation bsi){

        this();

	this.bsi = bsi;
	this.ppa = ppa;
	this.bla = bla;

        ppa.addObserver(this);
        bla.addObserver(this);

	ball_pos = ball_pos0 = 0.5;	    
        pos_percent = pos_percent0 = 0.5;
    }

    /*******************************************/
    /*             method                      */
    /*******************************************/

    /************* override Canvas **************/   

    public void paint(Graphics g) {

        //System.out.println("called paint();");

        if (buff == null ) {                     
        
            buff = createImage(width, height);
            gbuff = buff.getGraphics();

        }

        if (backField == null) {
            backField = createImage(width, height);
            gbf = backField.getGraphics();
            setBackField(gbf);

            gbuff.drawImage(backField,0,0,this);
	}

        g.drawImage(buff ,0,0,this);
    }

    public void update(Graphics g){

        paint(g);

    }

    /***************** override Observer *********************/
    public void update(Observable o, Object arg){

        System.out.println("called 1");

        if (o instanceof FormationAnalyzer){

            System.out.println("called 2");

            draw((FormationAnalyzer)o);

            repaint();

        }

	draw();

    }
 
    /**********************************************************/

    public void drawBackField(){

        gbuff.drawImage(backField,0,0,this);

    }

    public void clearGraphicsBuffer(){

        buff = null;
        backField = null;
    }

    public void createGraphicsBuffer(){

        buff = createImage(width, height);
        gbuff = buff.getGraphics();

        backField = createImage(width, height);
        gbf = backField.getGraphics();
        setBackField(gbf);

        gbuff.drawImage(backField,0,0,this);
    }

    private void setBackField(Graphics gb){

        Font defFont = gb.getFont();

        gb.setFont(new Font("b", Font.BOLD, 16));

        gb.setColor(Color.black);
        gb.drawRect(0,0,gwidth-1, gheight-1);
        gb.drawLine(0,gheight/2,gwidth,gheight/2);
        gb.drawString("+", gwidth - 20, 20);
        gb.drawString("-", gwidth - 20, gheight - 20);

        int fontSize = 12;
        int lineLength = 20;
        gb.setFont(new Font("a", Font.BOLD, fontSize));


        //gb.setColor(Eval.color);
        gb.setColor(Color.blue);
        gb.drawLine(gwidth+10, 40-fontSize - 5, gwidth+10+lineLength, 40-fontSize -5);
        //gb.drawString(Eval.NAME,gwidth,40);

        gb.drawString("POSSESSION PERCENTAGE",gwidth,40);

        gb.setColor(Color.red);
        //gb.setColor(Shihairitsu.color);
        gb.drawLine(gwidth+10, 70-fontSize - 5, gwidth+10+lineLength, 70-fontSize -5);
        //gb.drawString(Shihairitsu.NAME,gwidth,70);
        gb.drawString("RATE OF BALL IN OUR FIELD",gwidth,70);
        //gb.setColor(BallPos.color);
        //gb.drawLine(gwidth+10, 100-fontSize - 5, gwidth+10+lineLength, 100-fontSize -5);
        //gb.drawString(BallPos.NAME,gwidth,100);

        gb.setFont(defFont);

    }


    //override java.awt.Component 
    public Dimension getPreffererdSize(){

        return getSize();

    }    

    public void draw(FormationAnalyzer fa){

/*
        double ball_pos  = fa.getMyTeamPos();
        double ball_pos0 = fa.getBeforeMyTeamPos();
            
        double pos_percent  = fa.getPosPercentage();
        double pos_percent0 = fa.getBeforePosPercentage();

	int time  = fa.getTime();
	int time0 = fa.getBeforeTime();

	gbuff.setColor(Color.blue);
	    
	gbuff.drawLine(fitScaleX(time0),fitScaleY(pos_percent0*100  , 100, 0), fitScaleX(time), fitScaleY(pos_percent*100,100,0));

	gbuff.setColor(Color.red);
	    
	gbuff.drawLine(fitScaleX(time0),fitScaleY(ball_pos0*100, 100, 0) ,fitScaleX(time), fitScaleY(ball_pos*100, 100, 0));
*/
    }

    public void draw(){
	
	ball_pos0 = ball_pos;
	ball_pos  = bla.getBallPosPercentage(Team.LEFT);
	    
	pos_percent0 = pos_percent;
	pos_percent  = ppa.getPosPercentage(Team.LEFT);

	time0 = time;
	time  = bsi.time;

	gbuff.setColor(Color.blue);
	    
	gbuff.drawLine(fitScaleX(time0),fitScaleY(pos_percent0*100  , 100, 0), fitScaleX(time), fitScaleY(pos_percent*100,100,0));

	gbuff.setColor(Color.red);
	    
	gbuff.drawLine(fitScaleX(time0),fitScaleY(ball_pos0*100, 100, 0) ,fitScaleX(time), fitScaleY(ball_pos*100, 100, 0));

    }

    private int fitScaleX(int x){

	//System.out.println("x="+x * SCALE_X);

	return (int)(x * SCALE_X);  

    }

    private int fitScaleY(double val, int max, int min){

	System.out.println("val = "+val);
	   
	int y  = (int)(gheight - ((val - min) * gheight / (max - min)));
	    
	if (y < 1){y = 1;}
	else if (y >= gheight ){ y = gheight -1;} 

	return y;

    }

    public static void main(String arg[]){

	Frame  f = new Frame();
	KeiseiGraph kg  = new KeiseiGraph();
	f.add(kg);

	f.setVisible(true);

    }

}










