/*-------------------------------------------------------------------------*/
/*      OppAttackStatus.java                                               */ 
/*      Copyright (C) 2000 by  Sinji Futamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/10/22                                             */
/*-------------------------------------------------------------------------*/
//
//Ũѥ򤢤魯դΥ饹
//
package GUI;

import Information.*;
import Analyzer.*;

import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

//
//keisei wo arawasu graph
//

public class OppAttackStatus extends Panel implements Observer{

    /******************************************/
    /*        instance  variable              */
    /******************************************/

    OppAttackPatternAnalyzer oapa;
    FormationAnalyzer fa;

    Panel statusPanel = new Panel();
    Panel analyzePanel = new Panel();

    Label[] locationLabel= new Label[10];
    Label[] attackNumber = new Label[10];

    Label lineTitleLabel = new Label("My Defense Line",Label.RIGHT);
    Label formTitleLabel = new Label("Formation", Label.RIGHT);

    Label formLabel = new Label("NORMAL",Label.RIGHT);
    Label lineLabel = new Label("-", Label.RIGHT);

    /*********************************************/
    /*            constructor                    */
    /*********************************************/

    public OppAttackStatus(){

	init();

    }

    public OppAttackStatus(OppAttackPatternAnalyzer oapa, FormationAnalyzer fa){

        this();
        oapa.addObserver(this);
	this.oapa = oapa;
	this.fa = fa;
    }

    public OppAttackStatus(int width, int height) {
              
        setSize(width, height);
        setBackground(Color.white);

    } 

    /*******************************************/
    /*             method                      */
    /*******************************************/

    /***************** override Observer *********************/
    public void update(Observable o, Object arg){

        if (o instanceof OppAttackPatternAnalyzer){

	    String st = (String)arg;

	    if(arg.equals("LINE")){

		updateLine();

	    }else if (arg.equals("ATTACK")){

		updateAttack();

	    }

        }else if(o instanceof FormationAnalyzer){

	    Integer form = (Integer)arg;
	    updateFormation(form.intValue());

	}

    }
 
    private void init(){

	setBackground(Color.white);
	setLayout(new GridLayout(1,2));
	
	int counter = 0;

	for(int i = 0; i <= 4; i++){
	    
	    locationLabel[counter] = new Label(new Integer(i).toString(), Label.CENTER); 
	    counter++;	
	}

	for(int i = 4; i >= 0; i--){
	    
	    locationLabel[counter] = new Label(new Integer(i).toString(), Label.CENTER); 
	    counter++;	
	}

	statusPanel.setLayout(new GridLayout(11,2));

	statusPanel.add(new Label("Location", Label.CENTER));
	statusPanel.add(new Label("times", Label.CENTER));

	for(int i = 0; i <= 9; i++){
	
	    attackNumber[i] = new Label("0", Label.CENTER);
	    attackNumber[i].setBackground(Color.gray.brighter());
	    //attackNumber[i].setEnabled(false);

	    statusPanel.add(locationLabel[i]);
	    statusPanel.add(attackNumber[i]);
	}

	this.add(statusPanel);

	analyzePanel.setLayout(new GridLayout(10,1));
	analyzePanel.add(new Label(new String("")));
	analyzePanel.add(lineTitleLabel);
	analyzePanel.add(lineLabel);
	analyzePanel.add(formTitleLabel);
	analyzePanel.add(formLabel);

	this.add(analyzePanel);

    }

    protected void updateFormation(int form){

	if(form == FormationAnalyzer.WIDE){
	    
	    formLabel.setText("WIDE");

	}else if (form == FormationAnalyzer.NORMAL){

	    formLabel.setText("NORMAL");

	}else if (form == FormationAnalyzer.NARROW){

	    formLabel.setText("NARROW");

	}

    }

    protected void updateLine(){

	if (oapa.isMakeLine()){

	    lineLabel.setText("MADE");

	}else{

	    lineLabel.setText("BROKEN");

	}
	
    }

    protected void updateAttack(){

	int[] times = oapa.getOppAttackPattern();

	for(int i = 0; i <= 9; i++){

	    attackNumber[i].setText(new Integer(times[i]).toString());

	}
	
    }

    public static void main(String arg[]){

	Frame  f = new Frame();
	OppAttackStatus oas  = new OppAttackStatus();
	f.add(oas);

	f.setVisible(true);

    }

}










