/*-------------------------------------------------------------------------*/
/*      CoachInterface.java                                                */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*   soccerserverȥ֤                         */
/*   󥿡եȤʤ륯饹                     */ 
/******************************************************/
package Interface;

import Information.*;

import java.net.*;
import java.io.*;
import java.util.*;
public class CoachInterface extends BaseInterface {

    /**************************************/
    /*        instance variable           */
    /**************************************/
        
    public static String host, myTeamName;
    String eneTeamName = "Unknown";
    int port;
    int version;

    boolean isMyTeamLeft;
    
    public InetAddress iAddress;
    public DatagramSocket socket;
    //public Vector receiveMessages = new Vector(10);
 
    public CoachMessageParser cmp;

    //
    public Vector sendMessages;

    public boolean retAck;

    /**************************************/
    /*             teisuu                 */
    /**************************************/

    public static final int PACKET_SIZE = 4096;

    /**************************************/
    /*             constructor            */
    /**************************************/    
    
    public CoachInterface(String host, int port, String myTeamName, int version){

	this.host = host;
	this.port = port;
	this.myTeamName = myTeamName;
	this.version = version;

	sendMessages = new Vector();

    }

    /**************************************/
    /*               method               */
    /**************************************/    
    public void init(){
	
	//åȤκ
	init_socket();
	
	//åФؤinitå
       
	try{

	    if (version == 6){

		cmp = new CoachMessageParserForVer6x(this);
		connectSoccerServerOverVer6();

		//soccerserverv6.00team_names commandˤäŨ̾
		//Ǥ褦ˤʤä
		getEneTeamName();

	    }else{
 
		//С󣵰Τ

		cmp = new CoachMessageParser(this);
		connectSoccerServerUnderVer5();

	    }

	    //eye_onޥɤ
	    send_eye_on();

	}catch(IOException e){

	    e.printStackTrace();
	}

    }

    protected void init_socket(){

	try{

	    iAddress = InetAddress.getByName(host);
	    socket = new DatagramSocket();
	    socket.setSoTimeout(0);

	}catch(SocketException e) {

	    e.printStackTrace();

	}catch (UnknownHostException e){

	    e.printStackTrace();

	}

    }

    public void close(){

	socket.close();
	socket = null;

    }


    private void connectSoccerServerUnderVer5() throws IOException{

	//åФ(init MyTeamName)
	send_info("(init "+myTeamName+")");
		
	//portΤꤿΤgetMessageFromSoccerServerϻȤʤ
	byte[] buffer = new byte[PACKET_SIZE];
	DatagramPacket packet = new DatagramPacket(buffer,PACKET_SIZE);

	socket.receive(packet);

	String s = new String(buffer).trim();

	if (!s.equals("(init ok)")){

            System.err.println("connection failed");
            new IOException(s);

        }

	//ϿʥݡȤ³
	port =  packet.getPort();

    }

    private void connectSoccerServerOverVer6() throws IOException {

	//åФ(init MyTeamName version(6.00))
	send_info("(init "+myTeamName+" (version 6.00))");
		

	//portΤꤿΤgetMessageFromSoccerServerϻȤʤ
	byte[] buffer = new byte[PACKET_SIZE];
	DatagramPacket packet = new DatagramPacket(buffer,PACKET_SIZE);

	socket.receive(packet);

	String s = new String(buffer).trim();
	System.out.println(s);

	//äʸ󤫤饵ɤ
	StringTokenizer strtk = new StringTokenizer(s, " ()");

	String[] strs = new String[3];

	strs[0] = strtk.nextToken();
	strs[1] = strtk.nextToken();
	strs[2] = strtk.nextToken();

	if (strs[0].equals("init") && strs[2].equals("ok")){

	    if (strs[1].equals("l")){
		 
		//ΥɤˤäƱƶ򤦤ͤ,
		//CoachInterfaceCoachMessageParserΣ
		//Υ饹ˤ롣
		//ǤУĤˤޤȤ᤿..............
 
		isMyTeamLeft = true;
		cmp.reverse  = 1;
		System.out.println("My Team is left");

	    }else{

		isMyTeamLeft = false;
		cmp.reverse   = -1;
		System.out.println("My Team is right");
	    }
	}

	//ϿʥݡȤ³
	port =  packet.getPort();

    }


    // soccerserver over ver6.x only!
    //ˤʤ褦
    protected void getEneTeamName() throws IOException{

	String message = new String();

	do{

	    send_teamname_command();
	    message =  getMessageFromSoccerServer();
	    
	    StringTokenizer strtk = new StringTokenizer(message, " ()");
	    
	    String s1 = strtk.nextToken();

	    //ֻϤʤˤ

	    if(s1.equals("hear")){

		strtk.nextToken();
		
		if (strtk.nextToken().equals("referee")){
		    //
		    //Ũä˻礬ϤޤäƤޤä
		    //

		    //play modekickoff줿ۤ褤⤷ʤ
		    
		    //
		    //ȯԤteam_namesֻäƤ
		    //

		    getMessageFromSoccerServer();

		    break;

		}

	   }else if (s1.equals("ok") && strtk.nextToken().equals("team_names")){

		for(int i = 1; i <= 2; i++){
		    strtk.nextToken();
		}

		String team1 = strtk.nextToken();

		if( !team1.equals(myTeamName)){
		    
		    //Ũ̾狼ä

		    bsi.team[Team.RIGHT].name = team1;
		    eneTeamName = team1;

		    System.out.println("opp team is "+eneTeamName);

		    break;
		}

		if (strtk.hasMoreTokens()){

		    for(int i = 1; i <=2; i++){

			strtk.nextToken();

		    }

		    bsi.team[Team.RIGHT].name = eneTeamName = strtk.nextToken();
		    System.out.println("opp team is "+eneTeamName);
		    break;

		}
	    }


	    try{
		//⤷ޤŨʤ,äȤ
		sleep(1000);

	    }catch(InterruptedException e){
		e.printStackTrace();
	    }

	}while(true);

    }

    protected void send_teamname_command(){

	send_info("(team_names)");
	
    }

    protected void send_eye_on() throws IOException{

	//åФ(eye on)
	send_info("(eye on)");
		
	//åФ
	String s = getMessageFromSoccerServer();

	System.out.println(s);

	//⤷okΥå֤äƤʤä
	//㳰ȯ
	if (!s.equals("(ok eye on)")){

	    System.err.println("send eye on failed");
	    new IOException(s);

	}

    }

    //
    //Ǽäå򥵥åФ
    //
    //
    protected boolean send_info(String msg) {

	if (socket == null) return false;

	//System.out.println("send"+msg);

	int msglen = msg.length();
	byte[] message = new byte[msglen];
	message = msg.getBytes();
	DatagramPacket packet = new DatagramPacket(message, msglen,
						   iAddress, port);
	try {

	    socket.send(packet);

	    System.out.println("send message:"+msg);
 
	    retAck = false;
	    return true;
	    
	}catch (IOException e) {

	    System.err.println("send error " + msg);
	    e.printStackTrace();
	    
	    return false;
	}



    }

    public String getMessageFromSoccerServer() throws IOException {


	byte[] buffer = new byte[PACKET_SIZE];
	DatagramPacket packet = new DatagramPacket(buffer,PACKET_SIZE);

	socket.receive(packet);

	return new String(buffer).trim();

    }

    //  ǥХå
    //  
    //  ºݤưȤ,overrideϤ
    public void run(){

	int    ret;
	String message;

	while(true){

	try{

	    message = getMessageFromSoccerServer();
	    //åФåä
	    //receiveMessages.addElement(buffer);
	
	    //åɤ
	    ret = cmp.parse(message);

	}catch(EOFException e){
	    e.printStackTrace();
	}catch(IOException e){
	    e.printStackTrace();
	}

	    try{
		
		sleep(10);

	    }catch(InterruptedException e){

		e.printStackTrace();
		
	    }
		
	}

    }
    //
    //for debug
    //
    public static void main(String argv[]){

	CoachInterface  ci = new CoachInterface("kiyosu", 6002, "Saboten-Ice", 5);
	ci.init();
	
	ci.start();

    }


    public Vector getSendMessages(){
	
	return sendMessages;

    }


}








