/*-------------------------------------------------------------------------*/
/*      CoachMessageParser.java                                            */ 
/*      Copyright (C) 2000 by  Shinji Futamase [g95241@isc.chubu.ac.jp]    */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*   soccerserverΥå                   */
/*   ƤϤparser(                            */ 
/******************************************************/
package Interface;

import Information.*;

import java.util.zip.*;
import java.util.*;
import java.io.*;

public class CoachMessageParser {

    /**************************************/
    /*       instance variable            */
    /**************************************/    

    CoachInterface  parent;

    static int reverse = 1;
    String message;

    /**************************************/
    /*              teisuu                */
    /**************************************/    

    public static final int SEE           = 1;
    public static final int HEAR_REFEREE  = 2;
    public static final int HEAR_MY_TEAM  = 3;
    public static final int HEAR_OPP_TEAM = 4;
    public static final int ACK           = 5;

    /**************************************/
    /*             constructor            */
    /**************************************/    
    
    public CoachMessageParser(CoachInterface parent){

	this.parent = parent;
	
    }

    /**************************************/
    /*             method                 */
    /**************************************/   
    public int parse(String message) throws IOException, EOFException{

	message = message.trim();

	StringTokenizer strtk = new StringTokenizer(message, " ()");

	String firstWord = strtk.nextToken();

	if(firstWord.equals("hear")){

	    //İо֤äƤ

	    this.message = message;
	    //System.out.println(message);
	    return parseHearInformation(strtk);

	}else if (firstWord.equals("see")){

	    //System.out.println("see");

	    parseVisualInformation(strtk);

	    return SEE;

	}else if (firstWord.equals("ok")){
	    
	    String secondWord = strtk.nextToken();

	    if(secondWord.equals("say")){
		
		System.out.println(message);
		parent.retAck = true;

		return ACK;
		
		//fop.println(mg);

	    }else if (secondWord.equals("ear")){

		return ACK;

	    }

	}

	return -1;

    }

    protected void parseVisualInformation(StringTokenizer strtk){

	//System.out.println("at parse visual information");

	int currentTime = new Integer(strtk.nextToken()).intValue();
		
	//Time򥻥å
	
	parent.bsi.time = currentTime;

	//
	//goal֤ξϤȤФ
	//
	for(int i = 1; i <= 8; i++){

	    strtk.nextToken();

	}

	//(ball)
	strtk.nextToken();


	BallInformation ball = parent.bsi.ball;

	//ܡκɸ򥻥å
	ball.x = new Float(strtk.nextToken()).floatValue()*reverse;
	ball.y = new Float(strtk.nextToken()).floatValue()*reverse;

	//System.out.println("ball x"+ball.x);
	//System.out.println("ball y"+ball.y);

	for(int i = 1; i <= 2; i++){

	    strtk.nextToken();

	}
	
	if (!strtk.hasMoreTokens()){
	    return ;
	}

	//
	//player 
	//
	boolean first = true;

	while(strtk.hasMoreTokens()){

	    //player
	    strtk.nextToken();

	    String teamName = strtk.nextToken();
	    int unum =  new Integer(strtk.nextToken()).intValue();

	    int side;

	    //Υץ졼̣
	    //ؤϾ˺٤ȤƤ󤬤
	    if (parent.myTeamName.equals(teamName)){

		if (first == true){
		    reverse = 1;
		    first = false;
		    parent.isMyTeamLeft = true;

		}
		    side = Team.LEFT;

	    }else{   
         
		if (first == true){

		    //Υץ졼Ũ
		    parent.eneTeamName = teamName;
		    parent.bsi.team[Team.RIGHT].name = teamName;
		    reverse = -1;
		    first = false;
		    parent.isMyTeamLeft =false;

		}

		side = Team.RIGHT;

	    }

	    //ʤ
	    parent.bsi.team[Team.LEFT].name  = parent.myTeamName;
            parent.bsi.team[Team.RIGHT].name = parent.eneTeamName;

	    PlayerInformation p = parent.bsi.team[side].player[unum-1];

	    p.x = new Float(strtk.nextToken()).floatValue()*reverse;
	    p.y = new Float(strtk.nextToken()).floatValue()*reverse;

	    p.enable = 1;
	    p.unum   = unum;

	    //ñ̤äƤ롩
	    p.angle  = new Integer(strtk.nextToken()).intValue();

	    //ޤƤʤѥ᡼
	    for(int i = 1; i <= 3; i++){

		strtk.nextToken();

	    }

	}

    }

    protected int parseHearInformation(StringTokenizer strtk)
	                                     throws IOException{

	parent.bhi.time = new Integer(strtk.nextToken()).intValue();//ܤˤϡߤTime롣
	String direction = strtk.nextToken();//ܤˤϡƤޤϡ

	if (!direction.equals("referee")){ 

	    //********************//
	    //refereeʳİо //
	    //ʬϤϡ˵Ҥ. // 
	    //********************//

	    if (direction.equals("player")){
		
		String team = strtk.nextToken();

		if (team.equals(CoachInterface.myTeamName)){

		    //System.out.println(message);
		    parent.bhi.message = message;		 
		    return HEAR_MY_TEAM;
		   
   
		}else{

		    parent.bhi.message = message;
		    return HEAR_OPP_TEAM;

		}
	    }


	}else{

	    String pmode = strtk.nextToken();

	    System.out.println(pmode);
	    
	    //breakPoint();
	    
	    parsePlayMode(pmode);

	    return HEAR_REFEREE;
	    
	}

	return 0;

    }

    protected void parsePlayMode(String pmode){

	StringTokenizer stk = new StringTokenizer(pmode, "_");

	//
	//goalʤСä
	//

	String firstToken = stk.nextToken();
	String secondToken = "";
	if(stk.hasMoreTokens()){

	    secondToken = stk.nextToken();

	}
	
	if (firstToken.equals("goal") && (!secondToken.equals("kick"))){
	    
	    stk = new StringTokenizer(pmode, "_");
	    stk.nextToken();
	    parseGoal(stk);

	}
	else if(pmode.equals("before_kick_off")){

	    parent.bsi.play_mode = (int)CParam.BEFORE_KICK_OFF;
	    waitForKickOff();

	}
	else if(pmode.equals("half_time")){

	    parent.bsi.play_mode = (int)CParam.BEFORE_KICK_OFF;
	    endHalfGame();

	}
	else if(pmode.equals("time_up")){
	    
	    parent.bsi.play_mode = (int)CParam.TIME_OVER;
	    endGame();

	}else if (pmode.equals("foul_r") || pmode.equals("foul_l")){
	    
	    //ΣĤplay_modeˤʤ

	}else if (pmode.equals("free_kick_r") || pmode.equals("free_kick_l")){

	    stk = new StringTokenizer(pmode, "_");
	    stk.nextToken();
	    stk.nextToken();
    	    parseFreekick(stk);

	}
	else{
	    //goalǤϤʤä硢Τޤ
	    //playmodeShowInfo֥Ȥ롣

	    /* playmodeĤʤäΥ顼ȥåפ
	       && ׸Ψ
	    */

	    for (int i = 3; i < CParam.PLAYMODE_STRINGS.length; i++){

		if (CParam.PLAYMODE_STRINGS[i].equals(pmode)){

		    parent.bsi.play_mode = i;
		    break;

		}

	    }

	}

    }

    protected void waitForKickOff(){

	System.out.println("wait kick off");

    }

   protected void endHalfGame(){

   } 

   protected void endGame(){

       close();

   }

   protected void parseGoal(StringTokenizer stk){
   
       String sideChar = stk.nextToken(); 

       System.out.println(sideChar);

       if (!parent.isMyTeamLeft){

	   if (sideChar.equals("l")){

	       sideChar = "r";

	   }else{
	       sideChar = "l";
	   }
       }
       
       System.out.println(sideChar);

       //leftTeam뤷
       if(sideChar.equals("l")){

	   parent.bsi.team[0].score =  new Integer(stk.nextToken()).intValue();      
	   parent.bsi.play_mode = (int)CParam.GOAL_L;

       }
       //rightteam뤷
       else if(sideChar.equals("r")){

	   parent.bsi.team[1].score = new Integer(stk.nextToken()).intValue();
	   parent.bsi.play_mode = (int)CParam.GOAL_R;
	   System.out.println("enegoal");

       }
       else{
	   //۾֤ͤ줿
	   new IllegalArgumentException("Illegal Argument:"+sideChar);

       }

   }

   protected void parseFreekick(StringTokenizer stk){
   
       String sideChar = stk.nextToken(); 

       if (!parent.isMyTeamLeft){

	   if (sideChar.equals("l")){

	       sideChar = "r";

	   }else{
	       sideChar = "l";
	   }
       }

       if(sideChar.equals("l")){

	   parent.bsi.play_mode = (int)CParam.FREE_KICK_L;

       }
       else if(sideChar.equals("r")){

	   parent.bsi.play_mode = (int)CParam.FREE_KICK_R;	

       }
       else{
	   //۾֤ͤ줿
	   new IllegalArgumentException("Illegal Argument:"+sideChar);

       }

   }


    public void close(){


    }
    

}










