/*-------------------------------------------------------------------------*/
/*      NewLogParser.java                                                  */ 
/*      Copyright (C) 2000 by  Shinji Futamase [g95241@isc.chubu.ac.jp]    */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*   եΥȥ꡼फ                     */
/*   ƤϤparser(logfile)            */ 
/******************************************************/
package Interface;

import Information.*;

import java.util.zip.*;
import java.io.*;

public class NewLogParser implements LogParseInterface{ 

    LogInterface parent;
    
    private byte[] buffer = new byte[316];
    private byte[] byte16 = new byte[16];
 
    /**************************************/
    /*              teisuu                */
    /**************************************/    
 
    public static final boolean NOT_PARSE_HEARINFO = true;    

    /**************************************/
    /*             constructor            */
    /**************************************/    
    
    public NewLogParser(LogInterface parent){

	this.parent = parent;
	
    }

    /**************************************/
    /*             method                 */
    /**************************************/   

    //  streamǡ᤹

    public int parse() throws IOException, EOFException{

	int retVal;
	short mode;

	DataInputStream dis = parent.dis;

	mode = dis.readShort();

	switch (mode) {

	case 1:
	    
	    parseVisualInformation(dis);
	    retVal = 1;

	    break;

	case 2:

	    if(!NOT_PARSE_HEARINFO){

	    	parseHearInformation(dis);

	    }

       	    retVal = 2;
	    break;

	default:

	    new IllegalArgumentException();
	    retVal = -1;

	    break;
	}

	return retVal;

    }

    protected void parseVisualInformation(DataInputStream dis)
                                                   throws IOException{

	DataInputStream bufDis;

	//öХåեɤ߹
	dis.readFully(buffer);
	ByteArrayInputStream bis = new ByteArrayInputStream(buffer);
	bufDis = new DataInputStream(bis);

	//play mode
	parent.bsi.play_mode = (int)bufDis.readByte();

	//System.out.println(parent.bsi.play_mode);
	    
	//16bit align 
	bufDis.skipBytes(1);

	//team name and team score
	for (int i = 0; i < 2; i++){

	    //ɤ߹ɬפϤʤȻפΤ
	    //ɤ;Ϥ
	    //team name
	    bufDis.readFully(byte16);
	
	    int j = 0;

	    //
	    //ɤ߹ХȤ̾ʸ¸ߤϰϤ 
	    //
	    while( (char)byte16[j] != '\0' &&  j < 15){

		j++;

	    }
	    
	    parent.bsi.team[i].name  = new String(byte16, 0, j+1).trim();
	    parent.bsi.team[i].score = (int)bufDis.readShort();

	    //System.out.println(parent.bsi.team[i].name);

	} 

	//
	//ball information
	//
	BallInformation ball = parent.bsi.ball;

	//enable
	ball.enable = (int)bufDis.readShort();
	   
	//skip 
	bufDis.skipBytes(4);

	//angle
	ball.angle = (double)bufDis.readShort();
	    
	//location
	ball.x = CParam.ShowInfoToRealScale(bufDis.readShort());
	ball.y = CParam.ShowInfoToRealScale(bufDis.readShort());

	//
	//player
	//

	for (int i = 1; i < 23; i++){

	    PlayerInformation p = parent.bsi.team[i/12].player[(i>11)?i-12:i-1];
		
	    p.enable = (int)bufDis.readShort();

	    bufDis.skipBytes(2);
	    p.side = (int)(i / 11);

	    p.unum  = bufDis.readShort();
	    p.angle = (double)bufDis.readShort();
		
	    p.x = CParam.ShowInfoToRealScale(bufDis.readShort());
	    p.y = CParam.ShowInfoToRealScale(bufDis.readShort());

	}
	    
	//
	// time
	//
	parent.bsi.time = (int)bufDis.readShort();

	//System.out.println(parent.bsi.time);

    }

    protected void parseHearInformation(DataInputStream bufDis)
	                                     throws IOException{
	int len;

	//board
	parent.bhi.board = (int)bufDis.readShort();

	//message length
	len = bufDis.readShort();
	
	//get message
	byte[] disByte = new byte[len];
	bufDis.readFully(disByte, 0, len);

	//set message
	//parent.bhi.message  = new String(disByte);

    }
}








