/*-------------------------------------------------------------------------*/
/*      OldLogParser.java                                                  */ 
/*      Copyright (C) 2000 by  Shinji Futamase [g95241@isc.chubu.ac.jp]    */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/******************************************************/
/*   եΥȥ꡼फ                     */
/*   ƤϤparser                             */ 
/******************************************************/
package Interface;

import Information.*;

import java.util.zip.*;
import java.io.*;

public class OldLogParser implements LogParseInterface{ 

    LogInterface parent;
    
    private byte[] buffer = new byte[2052];
    private byte[] byte16 = new byte[16]; 

    /**************************************/
    /*             constructor            */
    /**************************************/    
    
    public OldLogParser(LogInterface parent){
	
    }

    /**************************************/
    /*             method                 */
    /**************************************/   

    //  streamǡ᤹

    public int parse() throws IOException, EOFException{

	int retVal;

	DataInputStream dis = parent.dis;
	DataInputStream bufDis;

	dis.readFully(buffer);

	//öХåեɤ߹
	ByteArrayInputStream bis = new ByteArrayInputStream(buffer);
	bufDis = new DataInputStream(bis);

	int mode = (int)bufDis.readShort();

	switch (mode){

	case 1:

	    retVal = 1;
	    parseVisualInformation(bufDis);

	case 2:

	    retVal = 2;
	    parseHearInformation(bufDis);

	default:
	    new IllegalArgumentException();
	    retVal = -1;

	}

	return retVal;

    }

    protected void parseVisualInformation(DataInputStream bufDis)
                                                   throws IOException{

	//play mode
	    parent.bsi.play_mode = (int)bufDis.readByte();
	    
	    //16bit align 
	    bufDis.skipBytes(1);

	    //team name and team score
	    for (int i = 0; i < 2; i++){

		//ɤ;Ϥ

		//team name
		bufDis.readFully(byte16);
		parent.bsi.team[i].name  = new String(byte16);
		parent.bsi.team[i].score = (int)bufDis.readShort();

	    } 

	    //
	    //ball information
	    //
	    BallInformation ball = parent.bsi.ball;

	    //enable
	    ball.enable = (int)bufDis.readShort();
	   
	    //skip 
	    bufDis.skipBytes(2);

	    //angle
	    ball.angle = (double)bufDis.readShort();
	    
	    //location
	    ball.x = CParam.ShowInfoToRealScale(bufDis.readShort());
	    ball.y = CParam.ShowInfoToRealScale(bufDis.readShort());

	    //
	    //player
	    //

	    for (int i = 1; i < 23; i++){

		PlayerInformation p = parent.bsi.team[i/11].player[(i>11)?i-12:i-1];
		
		p.enable = (int)bufDis.readShort();

		bufDis.skipBytes(1);
		p.side = (int)(i / 11);

		p.unum  = bufDis.readShort();
		p.angle = (double)bufDis.readShort();

		p.x = CParam.ShowInfoToRealScale(bufDis.readShort());

		p.y = CParam.ShowInfoToRealScale(bufDis.readShort());


	    }
	    
	    //
	    // time
	    //
	    parent.bsi.time = (int)bufDis.readShort();

	    System.out.println(parent.bsi.time);

    }

    protected void parseHearInformation(DataInputStream bufDis)
                                                  throws IOException{

	//board
	parent.bhi.board = (int)bufDis.readShort();

	//message
	byte[] byte2048 = new byte[2048]; 
	bufDis.readFully(byte2048);
	parent.bhi.message = new String(byte2048);

    }


}



