//
//
//
/******************************************************/
/*   ƥLogMonitor                               */
/*                                                    */
/******************************************************/

import Information.*;
import Interface.*;
import Analyzer.*;
import GUI.*;

import java.io.*;
import java.util.*;


public class LogMonitor extends LogInterface {

    /******************************************/
    /*         instance variable              */
    /******************************************/

    Vector analyzeItems = new Vector();

    KickAnalyzerDontUseFlag ka;
    PlayModeAnalyzer        pma;
    PassAnalyzer            pa;
    OneTwoPassAnalyzer      otpa;
    InterceptAnalyzer       ia;
    DribbleAnalyzer         da;
    PlayerLocationAnalyzer  pla;
    ShootAnalyzer           sa;
    GoalAnalyzer            ga;

    PosPercentageAnalyzer   ppa;
    BallLocationAnalyzer    bla;

    OppAttackPatternAnalyzer oapa;
    
    StrategyRelayEvaluater  sre;

    FormationAnalyzer  fa; 
    KeiseiGraph        kg;

    MessageSender          ms;

    GoalieMissAnalyzer gma;

    /******************************************/
    /*            constructor                 */
    /******************************************/

    public LogMonitor(String s){

	super(s);

    }


    /******************************************/
    /*             method                     */
    /******************************************/

    public void init(){
	
	super.init();
	
	ka  = new KickAnalyzerDontUseFlag(bsi);
	pma = new PlayModeAnalyzer(bsi);
	da  = new DribbleAnalyzer(ka, pma);
	pa  = new PassAnalyzer(ka, pma);
	oapa = new OppAttackPatternAnalyzer(bsi, ka, da, pa);

    }

    public void run(){

	while(true){

	    try{

		//logfile
		lpi.parse();

		pma.analyze();
		
		bsi.setChanged();
		bsi.notifyObservers(this);

		sleep(1);

	    }catch(EOFException e){

		break;

	    }catch(IOException e){

		e.printStackTrace();

	    }catch(InterruptedException e){

		e.printStackTrace();
		
	    }
		
	}

	try{
	    
	    PrintWriter pw = new PrintWriter(new FileOutputStream(super.getLogName()+".txt"));

	    for (int i = 0; i <= 9; i++){

		pw.print(oapa.getAttackedNumber(i));
		pw.print("\t");
		 
	    }

	    pw.println();

	    pw.close();

	}catch(IOException ie){
	    ie.printStackTrace();
	}

    }


    //
    //for test
    //
    public static void main(String argv[]){

	LogMonitor lm = new LogMonitor(argv[0]);

	lm.init();
	lm.start();
		    
    }

}
