/******************************************************/
/*   ǡ١ϿΤ˰եݴɤ   */
/*                                                    */
/******************************************************/

import Information.*;
import Interface.*;
import Analyzer.*;
import GUI.*;
import Utility.*;

import java.io.*;
import java.util.*;

public class LogMonitorForRoboDB extends LogInterface {

    /******************************************/
    /*         instance variable              */
    /******************************************/

    //ʬϥ֥
    KickAnalyzerUseFlag     ka;
    PlayModeAnalyzer        pma;
    PassAnalyzer            pa;
    OneTwoPassAnalyzer      otpa;
    InterceptAnalyzer       ia;
    DribbleAnalyzer         da;
    PlayerLocationAnalyzer  pla;
    ShootAnalyzer           sa;
    GoalAnalyzer            ga;

    PosPercentageAnalyzer   ppa;
    BallLocationAnalyzer    bla;

    OppAttackPatternAnalyzer oapa;
    StaminaAnalyzer          staa;    

    //ContinuousPlayAnalyzer   cpa;

    //ե
    FileOutputStream fo;
    PrintWriter fop;      

    //logname
    String logname;

    /******************************************/
    /*              teisuu                    */
    /******************************************/

    static int GAME_ID = -1;
    static int CUP_ID  = -1;
    static String CATEGORY = "?";
    static String GROUP    = "?";

    /******************************************/
    /*            constructor                 */
    /******************************************/

    public LogMonitorForRoboDB(String args[]){ 	

      	getOption(args);

    }

    public LogMonitorForRoboDB(String logname){ 	

      	super(logname);

    }

    /******************************************/
    /*             method                     */
    /******************************************/

    public void init(){
	
	super.init();

	//ʬϤ륪֥Ȥ
	ka  = new KickAnalyzerUseFlag(bsi);
	pma = new PlayModeAnalyzer(bsi);
	pla = new PlayerLocationAnalyzer(bsi);

	pa  = new PassAnalyzer(ka, pma);
	ia  = new InterceptAnalyzer(ka, pma);
	da  = new DribbleAnalyzer(ka, pma);
	otpa= new OneTwoPassAnalyzer(pa, ia, da, pma, pla);
	sa  = new ShootAnalyzer(bsi, ka);
	ga  = new GoalAnalyzer(bsi, pma, ka);

	ppa = new PosPercentageAnalyzer(pa, da);
	bla = new BallLocationAnalyzer(bsi);

    }

    public void run(){

	while(true){

	    try{

		//logfile
		if(lpi.parse() == 1){
	      	
  		    //analyze play_mode
		    pma.analyze();
		
	 	    // changed base see information
		    bsi.setChanged();
		    bsi.notifyObservers(this);
		}

		//sleep(1);

	    }catch(EOFException e){

		break;

	    }catch(IOException e){

		e.printStackTrace();

	    }/*catch(InterruptedException e){

		e.printStackTrace();
		
	    }*/
		
	}

        try{

            writeAnalysisForPostgres(getLogName());

        }catch(IOException e){

            e.printStackTrace();

        }


    }


    /*****************************************************************/
    /*            եؤν for postgres                      */
    /*****************************************************************/    

    private void writeAnalysisForPostgres(String baseName) throws IOException{

        fo = new FileOutputStream(baseName+".txt");
        fop = new PrintWriter(fo);      

        //٤ƥֶڤǽ
        writePGSQLHeader(fop);
        writeGameTable(fop);
        writeDribbleTable(fop);
        writePassTable(fop);
        writeOneTwoPassTable(fop);
        writeGoalTable(fop);
        writeShootTable(fop);
        writePlayerTable(fop);
	writeInterceptTable(fop);
	writePlaymodeChangeTable(fop);

        fop.close();
        fo.close();
    }

    /*************************************************************/
    /*         postgresΤΥإåκ              */
    /*************************************************************/
    protected void writePGSQLHeader(PrintWriter fop) throws IOException{
      
        fop.println("PGSQL_TXT");

    }

    /*************************************************************/
    /*         postgresΤΥơ֥κ              */
    /*************************************************************/
    protected void writeGameTable(PrintWriter fop) throws IOException{

        fop.println("GAME");

        //game id 
        fop.print(GAME_ID+"\t");

        //cup id
        fop.print(CUP_ID+"\t");

        //category final or preliminary
        fop.print(CATEGORY+"\t");

        //group  1stRound or semiFinal
        fop.print(GROUP+"\t");

        //̾(̾)
        String str = Utility.getFullPathFileToFile(getLogName());
        fop.print(str+"\t");

        //left team name
        fop.print(bsi.team[Team.LEFT].name+"\t");

        //right team name
        fop.print(bsi.team[Team.RIGHT].name+"\t");

        fop.println();

    }
    /*************************************************************/
    /*         postgresΤdribbleơ֥κ             */
    /*************************************************************/
    protected void writeDribbleTable(PrintWriter fop) throws IOException{
    
        fop.println("DRIBBLE");

        Enumeration enu = da.getDribbleVector().elements();

        while (enu.hasMoreElements()){
            
            Dribble dri = (Dribble)enu.nextElement();
            
            //mʲΥɥ֥ϥɥ֥ȿʤ
            if (dri.getTotalDistance() >= 1.0){

                //team id
                if (dri.getSide() == Team.LEFT){

                    //left team
                    fop.print(bsi.team[Team.LEFT].name+"\t");

                }else{

                    //right team
                    fop.print(bsi.team[Team.RIGHT].name+"\t");

                }

                DribblePoint dp1, dp2;
                dp1 = dri.getFirstDribble();
                dp2 = dri.getLastDribble();

                //startTime
                fop.print(dp1.getTime()+"\t");
            
                //end time
                fop.print(dp2.getTime()+"\t");

                //player num
                fop.print(dri.getMember()+"\t");
            
                //startx
                fop.print(dp1.getX()+"\t");
            
                //starty
                fop.print(dp1.getY()+"\t");

                //endx
                fop.print(dp2.getX()+"\t");

                //endy
                fop.print(dp2.getY()+"\t");

                //distance
                fop.print(dri.getTotalDistance()+"\t");

                fop.println();
            }
        }


    }
    /*************************************************************/
    /*         postgresΤgoal   ơ֥κ             */
    /*************************************************************/
    protected void writeGoalTable(PrintWriter fop) throws IOException{

        fop.println("GOAL");

        Enumeration enu = ga.getGoalVector().elements();

        while (enu.hasMoreElements()){
            
            Goal goal = (Goal)enu.nextElement();
            
            //team id
            if (goal.getSide() == Team.LEFT){

                //left team
                fop.print(bsi.team[Team.LEFT].name+"\t");

            }else{

                //right team
                fop.print(bsi.team[Team.RIGHT].name+"\t");

            }
            
            //Time
            fop.print(goal.getTime()+"\t");

            //player num
            fop.print(goal.getMember()+"\t");
            
            //own?
            if (goal.isNoOwnGoal()){
                fop.print("0\t");
            }else{
                fop.print("1\t");
            }

            fop.println();

        }

    }
    /*************************************************************/
    /*         postgresΤshootơ֥κ             */
    /*************************************************************/
    protected void writeShootTable(PrintWriter fop) throws IOException{
    
        fop.println("SHOOT");

        Enumeration enu = sa.getShootVector().elements();

        while (enu.hasMoreElements()){
            
            Shoot shoot = (Shoot)enu.nextElement();
            
            //team id
            if (shoot.getSide() == Team.LEFT){

                //left team
                fop.print(bsi.team[Team.LEFT].name+"\t");

            }else{

                //right team
                fop.print(bsi.team[Team.RIGHT].name+"\t");

            }
            
            //Time
            fop.print(shoot.getTime()+"\t");
            //player num
            fop.print(shoot.getMember()+"\t");

            //pos_x
            fop.print(shoot.getPosX()+"\t");
            
            //pos_y 
            fop.print(shoot.getPosY()+"\t");

            //塼ȤεΥ
            fop.print(shoot.getDistance()+"\t");

            fop.println();

        }

    }

    /*************************************************************/
    /*         postgresΤpassơ֥κ             */
    /*************************************************************/
    protected void writePassTable(PrintWriter fop) throws IOException{
    
        fop.println("PASS");

        Enumeration enu = pa.getPassVector().elements();

        while (enu.hasMoreElements()){
            
            Pass pass = (Pass)enu.nextElement();
            
            //team id
            if (pass.getSide() == Team.LEFT){

                //left team
                fop.print(bsi.team[Team.LEFT].name+"\t");

            }else{

                //right team
                fop.print(bsi.team[Team.RIGHT].name+"\t");

            }
            
            //pass Time
            fop.print(pass.getPassTime()+"\t");

            //recv time
            fop.print(pass.getRecvTime()+"\t");

            //passer player num
            fop.print(pass.getPasserUnum()+"\t");

            //receiver player unum
            fop.print(pass.getReceiverUnum()+"\t");

            //pass pos_x
            fop.print(pass.getPassX()+"\t");
            
            //pass pos_y 
            fop.print(pass.getPassY()+"\t");

            //recv pos_x
            fop.print(pass.getRecvX()+"\t");

            //repcv pos_y
            fop.print(pass.getRecvY()+"\t");

            fop.println();

        }

    }

    /*************************************************************/
    /*         postgresΤ1-2passơ֥κ             */
    /*************************************************************/
    protected void writeOneTwoPassTable(PrintWriter fop) throws IOException{
    
        fop.println("1-2PASS");

        Enumeration enu = otpa.getOneTwoPassVector().elements();

        while (enu.hasMoreElements()){
            
            OneTwoPass otPass = (OneTwoPass)enu.nextElement();
            Pass pass1 = otPass.getFirstPass();
            Pass pass2 = otPass.getSecondPass();

            //game id 
            //fop.print(GAME_ID+"\t");

            //team id
            if (pass1.getSide() == Team.LEFT){

                //left team
                fop.print(bsi.team[Team.LEFT].name+"\t");

            }else{

                //right team
                fop.print(bsi.team[Team.RIGHT].name+"\t");

            }
            
            //pass Time
            fop.print(pass1.getPassTime()+"\t");

            //recv time
            fop.print(pass2.getRecvTime()+"\t");

            //passer player num
            fop.print(pass1.getPasserUnum()+"\t");

            //receiver player unum
            fop.print(pass1.getReceiverUnum()+"\t");
            fop.println();

        }

    }

    /*************************************************************/
    /*         postgresΤplayerơ֥κ             */
    /*************************************************************/
    protected void writePlayerTable(PrintWriter fop) throws IOException{

        fop.println("PLAYER");

        for (int side = 0; side <= 1; side++){
            for (int unum = 1; unum <= 11; unum++){

	        if (side == Team.LEFT){

		    //left team
                    fop.print(bsi.team[Team.LEFT].name+"\t");

                }else{

                    //right team
                    fop.print(bsi.team[Team.RIGHT].name+"\t");

            	}
	
                //player num
        	fop.print(unum+"\t");

            	//player distance
            	fop.print(pla.getDistance(side, unum)+"\t");
            	fop.println();

	    }

        }

    }

    /*************************************************************/
    /*         postgresΤplaymode_changeơ֥κ     */
    /*************************************************************/
    protected void writePlaymodeChangeTable(PrintWriter fop) throws IOException{
    
        fop.println("PLAYMODE_CHANGE");

        Enumeration enu = pma.getPlayModeVector().elements();

        int play_mode0 = CParam.BEFORE_KICK_OFF;

        while (enu.hasMoreElements()){

	    PlayMode pm = (PlayMode)enu.nextElement();
            
            //game id 
            //fop.print(GAME_ID+"\t");
            
            //playmode change Time
            fop.print(pm.time+"\t");

            //before play mode
            fop.print(play_mode0+"\t");

            //after play mode
            fop.print(pm.pmode+"\t");

	    play_mode0 = pm.pmode;

            fop.println();

        }

    }


    /*************************************************************/
    /*         postgresΤpassơ֥κ             */
    /*************************************************************/
    protected void writeInterceptTable(PrintWriter fop) throws IOException{
    
        fop.println("INTERCEPT");

        Enumeration enu = ia.getInterceptVector().elements();

        while (enu.hasMoreElements()){
            
            Intercept inter = (Intercept)enu.nextElement();
            
            //team id
            if (inter.getIntercepterSide() == Team.LEFT){

                //left team
                fop.print(bsi.team[Team.LEFT].name+"\t");

            }else{

                //right team
                fop.print(bsi.team[Team.RIGHT].name+"\t");

            }
            
            //before intercept Time
            fop.print(inter.getBeforeInterceptTime()+"\t");

            //intercpet time
            fop.print(inter.getInterceptTime()+"\t");

            //intercepted unum
            fop.print(inter.getInterceptedUnum()+"\t");

            //intercepter unum
            fop.print(inter.getIntercepterUnum()+"\t");

            //before intercept pos_X
            fop.print(inter.getBeforeInterceptX()+"\t");
            
            //before intercept pos_Y 
            fop.print(inter.getBeforeInterceptY()+"\t");

            //intercept pos_x
            fop.print(inter.getInterceptX()+"\t");

            //intercept pos_y
            fop.print(inter.getInterceptY()+"\t");

            fop.println();

        }

    }

    //
    //for test
    //
    public static void main(String argv[]){

	LogMonitorForRoboDB lm = new LogMonitorForRoboDB(argv);

	lm.init();
	lm.start();
		    
    }

    protected void getOption(String args[]){

        int i = 0;

        while (i < args.length){

            String str = args[i];

            if ((str.compareTo("-f") == 0) && ((i+1) < args.length) ){

		setLogName(args[i+1].trim());
                i+=2;

            }else if ((str.compareTo("-g") == 0) && ((i+1) < args.length) ){

                GAME_ID = new Integer(args[i+1]).intValue();
                i+=2;
            }else if ((str.compareTo("-c") == 0) && ((i+1) < args.length)){
            
                CUP_ID = new Integer(args[i+1]).intValue();
                i+=2;

            }else if ((str.compareTo("-cat") == 0) && ((i+1) < args.length)){

                CATEGORY = args[i+1].trim();
                i+=2;

            }else if ((str.compareTo("-grp") == 0) && ((i+1) < args.length)){

                GROUP = args[i+1].trim();
                i+=2;

            }else if (str.compareTo("-h") == 0){
              
                usage();
                System.exit(1);

            }else{
                usage();
                System.exit(1);

            }
        }       

    }

    protected void usage(){

        System.out.println("usage: java LogMonitor [-h] [-c cupID] [-g gameID] [-cat category]");
        System.out.println("                       [-grp group] [-f file]");
        System.out.println("-h      print this help");
        System.out.println("-c      set cup id");
        System.out.println("-g      set game id");
        System.out.println("-grp    set group. for example groupA, groupB, final, etc...");
        System.out.println("-cat    set category. for example preliminary, final, evaluation, etc...");

    }

}
