//
//
//
/******************************************************/
/*   GUIդ LogMonitor                               */
/*                                                    */
/******************************************************/

import Information.*;
import Interface.*;
import Analyzer.*;
import GUI.*;

import java.io.*;
import java.util.*;
import java.awt.*;

public class LogMonitorWithGUI extends ApplicationLogInterface
                               implements GameControlPanelEventListener {

    /******************************************/
    /*         instance variable              */
    /******************************************/

    KickAnalyzerDontUseFlag ka  = new KickAnalyzerDontUseFlag(bsi);

    FieldCanvas fc;
    GameControlPanel gcp;
    Frame f;

    /******************************************/
    /*            constructor                 */
    /******************************************/

    public LogMonitorWithGUI(String s){

	super(s);

    }


    /******************************************/
    /*             method                     */
    /******************************************/

    public void init(){
	
	super.init();
	
	f = new Frame();
	f.setLayout(new BorderLayout());

	FieldCanvas c = new FieldCanvas((int)CParam.LENGTH_MAGNIFY_MIDDLE,bsi);
	GameStatusPanel gsp = new GameStatusPanel(bsi);
	gsp.init();

	gcp = new GameControlPanel(this);
	gcp.init();

	f.add("Center",c);
	f.add("North",gsp);
	f.add("South",gcp);

	f.setSize(710,555);
	f.setVisible(true);

    }

    public void run(){

	while(true){

	    try{

		//logfile
		lpi.parse();

	        ka.analyze();

		bsi.setChanged();
		bsi.notifyObservers();

		sleep(100);

	    }catch(IOException e){

		e.printStackTrace();

	    }catch(InterruptedException e){

		e.printStackTrace();
		
	    }
		
	}

    }

    /*********************************************/
    /* GameControlPanelEventListener       */
    /*********************************************/

    public void stopPushed(){};
    public void closePushed(){System.exit(0);};
    public void pausePushed(){};
    public void restartPushed(){};

    /*********************************************/
    /*                main method                */ 
    /*********************************************/

    public static void main(String argv[]){

        LogMonitorWithGUI lm = new LogMonitorWithGUI(argv[0]);

	lm.init();


	try{
	  Thread.sleep(10000);
	}catch(Exception e){
	  e.printStackTrace();
	}

	lm.start();
		    
    }

}









