/*-------------------------------------------------------------------------*/
/*      BallClearStrategy.java                                             */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*           ܡ륯ꥢά饹                 */
/*                                                  */
/****************************************************/
package Strategy;

import Analyzer.*;
import Information.*;
import Interface.*;

import java.util.*;

public class BallClearStrategy extends BaseStrategy{

    /*************************************************/
    /*            instance variable                  */
    /*************************************************/

    //+
    boolean sideClear =false;
    boolean forwordClear=false;
    boolean outOfBounds=false;
    boolean continueCounter = false;

    //-
    boolean intercepted=false;
    boolean shooted=false;
    boolean goaled=false;
    
    public BallClearStrategy(int time, int unum, StrategyRelayEvaluater sre
			     ,String type){

	super(time, unum, sre, type);
	
    }

    public int update(Observable o, Object arg){

	//play_modeѲ
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    int mode = pma.getCurrentPlayMode();

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF
                  && (!(mode == CParam.GOAL_L || mode == CParam.GOAL_R))){

		if (mode == CParam.KICK_IN_L || mode == CParam.KICK_IN_R){

		    outOfBounds = true;
			
		}
		
		evaluate();
		return END;

	    }

	}else if (o instanceof GoalAnalyzer){

	    Goal goal = (Goal)arg;

	    System.out.println("goal side = "+goal.getSide());

	    if (goal.getSide() == Team.RIGHT){

		goaled = true;
		evaluate();
		return END;

	    }

	}else if (o instanceof ShootAnalyzer){

	    Shoot shoot = (Shoot)arg;

	    if (shoot.getSide() == Team.RIGHT){

		shooted = true;
		return CONTINUE;

	    }

	}else if (o instanceof InterceptAnalyzer){
	    
	    intercepted = true;
	    
	    return CONTINUE;

	}

	return CONTINUE;

    }

    //
    //άstrˤάڤ줿Τɾ
    //(άɤάˤĤʤäɾ)
    //
    
    public void evaluate(String str){
	
	if (str.equals("counter")){

	    continueCounter = true;	    
	}
	
	evaluate();

    } 

    public void evaluate(){

	double ballx = sre.bsi.ball.x ;
	double bally = sre.bsi.ball.y;

	if (ballx >= -25.0){
	    
	    forwordClear = true;

	}

	if (bally >= 18.0 || bally <= -18.0){

	    sideClear    = true;

	}

	print();

    }
 
    public String getResult(){

	String str =new String();

	if(sideClear){str=str+"Y";}else{str=str+"N";}
	if(forwordClear){str=str+"Y";}else{str=str+"N";}
	if(outOfBounds){str=str+"Y";}else{str=str+"N";}
	if(continueCounter){str=str+"Y";}else{str=str+"N";}
	if(intercepted){str=str+"Y";}else{str=str+"N";}
	if(shooted){str=str+"Y";}else{str=str+"N";}
	if(goaled){str=str+"Y";}else{str=str+"N";}

	return str;

    }

    public void print(){
	
    System.out.println("sideClear"+sideClear);
    System.out.println("forwardClear"+forwordClear);
    System.out.println("outOfBounds"+outOfBounds);
    System.out.println("continueCounter"+continueCounter);
    
    //-
    System.out.println("intercepted"+intercepted);
    System.out.println("shooted"+shooted);
    System.out.println("goaled"+goaled);
    
    }


}



