/*-------------------------------------------------------------------------*/
/*      CounterStrategy.java                                               */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*           $B%\!<%k%/%j%"@oN,%/%i%9(B                 */
/*                                                  */
/****************************************************/
package Strategy;

import Analyzer.*;
import Information.*;
import Interface.*;

import java.util.*;

public class CounterStrategy extends BaseStrategy{

    /*************************************************/
    /*            instance variable                  */
    /*************************************************/

    //+
    boolean successForwardPass = false;

    //-
    boolean countered = false;
    boolean goaled    = false;
    boolean shooted   = false;
    boolean intercepted = false;
    
    public CounterStrategy(int time, int unum, StrategyRelayEvaluater sre,
			   String type){

	super(time, unum, sre,type);
	
    }

    public int update(Observable o, Object arg){

	//play_mode$B$,JQ2=$7$?(B
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    int mode = pma.getCurrentPlayMode();

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF
                  && (!(mode == CParam.GOAL_L || mode == CParam.GOAL_R))){

		evaluate();
		return END;

	    }

	}else if (o instanceof GoalAnalyzer){

	    Goal goal = (Goal)arg;

	    System.out.println("goal side = "+goal.getSide());

	    if (goal.getSide() == Team.RIGHT){

		goaled = true;
		evaluate();
		return END;
	    }

	}else if (o instanceof ShootAnalyzer){

	    Shoot shoot = (Shoot)arg;

	    if (shoot.getSide() == Team.RIGHT){

		shooted = true;
		return CONTINUE;

	    }

	}else if (o instanceof InterceptAnalyzer){
	    
	    intercepted = true;
	    
	    return CONTINUE;

	}else if (o instanceof PassAnalyzer){

	    Pass pass = (Pass)arg;

	    if(pass.getSide() == Team.LEFT){

		//$BAj<j?X$^$G96$a9~$s$@(B
		if (pass.getRecvX() >= 0.0){
		    
		    successForwardPass = true;

		}
		    
	    }
	}   

	return CONTINUE;
	
    }

    //$B@oN,$,ES@Z$l$?$N$GI>2A$9$k(B
    public void evaluate(){

	print();

    } 

    public void evaluate(String str){

	evaluate();
    }


    public String getResult(){

	String str =new String();

	if(successForwardPass){str=str+"Y";}else{str=str+"N";}
	if(countered){str=str+"Y";}else{str=str+"N";}
	if(shooted){str=str+"Y";}else{str=str+"N";}
	if(goaled){str=str+"Y";}else{str=str+"N";}

	return str;

    }

    public void print(){

    //+
    //-
    boolean countered = false;
    boolean goaled    = false;
    boolean shooted   = false;
    boolean intercepted = false;

    System.out.println("successForwardPass"+successForwardPass);

    //-
    System.out.println("countered"+countered);
    System.out.println("shooted"+shooted);
    System.out.println("goaled"+goaled);
    
    }


}



