/*-------------------------------------------------------------------------*/
/*      OneTwoReturnStrategy.java                                          */ 
/*      Copyright (C) 2000 by  Sinji Ftamase [g95241@isc.chubu.ac.jp]      */
/*      Last Update 2000/08/26                                             */
/*-------------------------------------------------------------------------*/

/****************************************************/
/*               1-2pass$B@oN,%/%i%9(B                  */
/*                                                  */
/****************************************************/
package Strategy;

import Analyzer.*;
import Information.*;
import Interface.*;

import java.util.*;

public class OneTwoReturnStrategy extends BaseStrategy{

    /*************************************************/
    /*            instance variable                  */
    /*************************************************/

    //+
    boolean successPass = false;

    //-
    boolean intercepted = false;
    boolean offsided    = false;
    
    public OneTwoReturnStrategy(int time, int unum, StrategyRelayEvaluater sre
				, String type){
	super(time, unum, sre, type);
	
    }

    public int update(Observable o, Object arg){

	//play_mode$B$,JQ2=$7$?(B
	if (o instanceof PlayModeAnalyzer){

	    PlayModeAnalyzer pma = (PlayModeAnalyzer)o;

	    int mode = pma.getCurrentPlayMode();

	    if (mode == CParam.OFFSIDE_L){

		offsided = true;

	    }

	    if (pma.getInformation() == PlayModeAnalyzer.PLAY_ON_TO_OFF
                  && (!(mode == CParam.GOAL_L || mode == CParam.GOAL_R))){

		evaluate();
		return END;

	    }

	}else if (o instanceof InterceptAnalyzer){
	    
	    intercepted = true;
	    return CONTINUE;

	}else if (o instanceof PassAnalyzer){

	    Pass pass = (Pass)arg;

	    if(pass.getSide() == Team.LEFT){
		    
		successPass = true;
		    
	    }
	}   

	return CONTINUE;
	
    }

    //$B@oN,$,ES@Z$l$?$N$GI>2A$9$k(B
    public void evaluate(){

	print();

    } 

    public void evaluate(String str){

	print();

    }

    public String getResult(){

	String str =new String();

	if(successPass){str=str+"Y";}else{str=str+"N";}
	if(intercepted){str=str+"Y";}else{str=str+"N";}
	if(offsided){str=str+"Y";}else{str=str+"N";}

	return str;

    }

    public void print(){

	//+
	System.out.println("successPass"+successPass);

	//-
	System.out.println("intercepted"+intercepted);
	System.out.println("offsided"+offsided);
    
    }


}



